{--------------------------------------------------------------------}
{ TmwDList V 1.0                                                     }
{ Written by Martin Waldenburg 1996.                                 }
{ Copyright by Martin Waldenburg 1996. All rights reserved.          }
{ This is FreeWare.                                                  }
{ Not testet with Delphi1.                                           }
{ It's provided as is, without a warranty of any kind.               }
{ You use it at your own risc.                                       }
{ You may use and distribute it freely.                              }
{ But You may not say it's your work                                 }
{ If you distribute it you must provide all Files.                   }
{--------------------------------------------------------------------}
{ This Component demonstrates the implementation and use of a        }
{ sortable doubly linked list using MergeSort.                                }
{ I couldn't find a doubly linked list implemented as a component,   }
{ I wrote it myself.                                                 }
{ I implemented this with MergeSort because I've wasted so mucht     }
{ time waiting for sorting.                                          }
{ Mergesort is most efficient if used with linked lists, in which    }
{ case it comes very close to the theoretically most efficient       }
{ sorting algorithm possible.                                        }
{ This is only a simple implementation, you can double the speed     }
{ verry easy.  However it's fast, fast, fast.                        }
{ Take care only allocating enough memory that Windows doesn't swap. }
{ In this case you must sort parts, save to disc, then merge the     }
{ disc files                                                         }
{ Enjoy it's free.                                                   }
{--------------------------------------------------------------------}
{ the following contains additional files that should be included with this
  file.  To extract, you need XX3402 available with the SWAG distribution.

  1.     Cut the text below out, and save to a file  ..  filename.xx
  2.     Use XX3402  :   xx3402 d filename.xx
  3.     The decoded file should be created in the same directory.
  4.     If the file is a archive file, use the proper archive program to
         extract the members.

{ ------------------            CUT              ----------------------}


*XX3402-050610-200797--72--85-27644------MWSORT.ZIP--1-OF-12
I2g1-+c+++++++S3DW8W2UCUeGE++8YY+++A++++PLR2PrJWP4IiSaZkI2g1--E++++6++Zq
K05egMWETk+++9U0+++9++++HLR2H4ZnR0tYMr7XM4-UI+1WzzwV4-pYA12k461ZaFV045kN
kVZQ45kMD-a0UHkM2--UNs4lBFUUtc2k6kBIa6Y--qU+6sO4-UU3UY14UEA5U1F6t1wMUFk4
dY+Ev2sEHH5sU5+5V6yE+S6zNkuUwh5ZoTHzUIXxUOaVb6xizh-q5rfsMcMzGE++I2g1--E+
+++6+2lTKm5hMvjVxU6++5+5+++7++++JKtdR12iN4NhVNL9Phd+36M5CvOt-26WNJ3pAth8
uO7JO7hq2qIF04dI08VMMZId+ltU3CB-sm2-8GxEeLqDffjcijieuiJRiasxsxhk8Kk4arDy
vtntty8zSK1LKqyP3L-QjfM+gBjpMxCiInOi459QOS+-pvw-rOMHXFdRsj0FzYUnLqAm555x
64BJoMEHudYbBHmaY+sUUXtZ5DJQ1-ouvPZnu-9j-Xj-XwzVp0TS21Ml4q8FZexHXnyhIdQm
OvTjRcbbo1gPnrV--g6mqdyQT9h0MqkKalrMENsDCtWFEOXjw9a90u1M7XDgyarA9fryG9jC
0p028+9HPe+SRYotFVDv8GSazk9FnBs1AwtD7jOkGWRn7ju2HQEswK+LiEvqSZAq-A0mnuSQ
IqybEN2XcJdNabIE6fIrAT3-EdGtKFjpKgn-H+BKmuiud5xXtIF+DWfUWlbVMPTLaOpYYNmG
AmZN-08mMJwsV-hW04rExWLrGKH0dwG2klGZ9SVS81fxCxUYp+56qRIFvhyQopYiTcU8jtC+
9l3+iszpywaAGZp4C6NjwGpaDZNQqobaJYeUmxNpUVqafUbPs7n6HSZ4udk6f61F9JP+yaSk
WFkYdqFH6ES-pHJtfbfvQOCrpZdjbmbSOfCcAFH9xt940dR1Xn6AewVLyggiB-CmUUCWvV-h
jeOLL4dDiMNRnD53SA9bJxH-jbfMhDpZG4fJWX13tlDP1dSHJWowKSWuhe5fEhepIGTAtkih
HjuzecLvopBs70KDIxlioaJSVdPqHPPBw0qVowUEaBZKdLE86Hm8JIeVMZ8c42SLxyVJQDa3
RGNPuyHDF-qVI4eIodoe6gjw-cfRyfeJjrhqRWwe06pGMIytyN0ztbtu4FPs5JvH5y91w0en
NWb9+-HgpUFvBM7QCWmYXtJWbPVMwCG5kX65jbU7qHx0BgU6yTWi5jFVYn2ql--x7TPYzDFg
Y76BIaeBs2BaW83WWggVi7LmsJ4G7maPr3KVyXVI4s2Oz+BEGkA23+++++U+243P6GV6WWFR
+E++P+A+++k+++-EQaxeNKBoAGtmNLCZIv3Ckn+EDHSJoWuYGCloN4FfBo-A1A+jg8+mJY7e
j44dEnmmKZbsXGW9DuIXMuECMOVur1ZpsVGMSDO9wyvSqItY+k-AWMUBXz2twDa683lgAca5
Dbxle9wa0XW2-z+5ZCiUJ1BkclRf9MoQERRt6qvUtjN3Xp4hJmhNuuRuBaQfuQLWdRP9Hjwb
fnoIOkpNmj-OzgW1FiR6LHpDe34qSTSl3AVGePNmrKUCd3YmmzEQT2+jhr6twUM8I7eKxEOU
uhQc4YZjI9DAyGux+QEdctJU0acap2JS38oQtoJdGVBcYlgHudkRLHpfwltcItFt7q3gSaZO
gClfAY+Dsq-qVqDR8nxU+t1wFYd3bVMUfWWq6x87WR48BJMUQ1Tsk3pGsNvDYcoOec+q7WO6
arD2WjVpVPUb6jCBW4So+Dxol-CsVlisUkTW9HnGu-5S0vsB+ePHsHDT0ft3+fs-I2g1--E+
+++6+1iDK04UT2HIZk+++BY++++A++++I57jOaJXR12iN5-m8mX8Hmx8n3I68AfDGYoiAPHa
tS9Z8WpC9SPZIZ-kmmz89RM-gI9nAYgA3H9n3BH-99q0l47pVKeEj42hK23iiMhDNb27K+aI
1JM2BexO7IV-Gmz6BPUKl2h8HQzA+yZl90X6mIlC9AbAnxDn--ePaNWHKNJeXGvZL7GOK768
gYgX-4mX1hVVVdcM8cB8ws-WeLYdSflQ+3-9+kEI++++0++KMJgV4uj1k0Q-++1Y+E++1+++
+3-mPqdZMrEl9aFjNYqEEJD0A-03vtrdTu31FFmb-u-3I7-8EJG4EmUFJYeGGR6-zTLadHdu
yTfSqqmmrTJ+bVFJL4z0c7R2MR+5-YYf136U+sP+5EcXM+nQ+kwcH6+dw6Vg-iH+2v6tIA+i
U0LgAxE8uULe3ScBeXX6wsW2BPv7aFLHUgHSyuIUqui64KuG3Mb3dqf2HdvBfTjaKdNzEPeZ
tYEznK0Oucz7h4to46H-SY9Wu-QkNKfcRc55NfJJhNphDznH+maAf5VD8ImNwaqx5shruLyQ
F43NSGncWmRFdxqBQQzZLxO8ipTL5PSq2xjnjVgzWOCPiBpm-vA9HvYdBGZ9IWFyadEo9urI
lAraRkuLiK9-aGsDCPC5l6yo6rGlmXGBCRDgl0rLu7jLkbjIjU3EGkA23+++++U+CblL6HR+
FAKM+U++1UQ+++g+++-BRqFgOLBo9bBkMrpIHKyXA-0x6z2TC5OXOVLGdVydC5GPNPJGIoIZ
PEzh5VmM7dP+FfN7hrjMrvsS+wM3iXY2nzXBj1QDvCQPLdGQ+JCzTCyC3-+JPwhP8dLjfEIj
EOXr4psl3NrurUfIbaRp47sPE3d5Ixy98xM2cSzRt2F8VhoqhZpAQn0dPD4GEJviuRzkuzEZ
HJwuFd81IZ0G5QfkjKiKUZFQF-ifojQGFJV4F9M08HLE0bWE6DetvkRRMWDTSqtacW1piBA6
ql6-e3pFnbkjXCvV+270tbin883zkDRCccE9VFbR6B3mB6CdbW-yUg+7cWMiUrOh81FtnMB+
l05AcCtf9yjR5u-4VDEPLkh-rbjuFlJQ8mLchZ6hFjwAn1lboMBtbXGllXytKYMv7a-IpMWm
qiNIvh4Do+paRN-WaNDKtMx2I99B4nrlm8mlurfQqVsvjhw1mNs2JPLnEYT-o9PU1F5-46Cd
g1Eho8Kh2QXRvfMuaVoXlitpoZnvw2V+JUY6Ze0zNHXGs46F7DeBgBqL8pHGEK98gU3+nxxC
ckRQ2YK0FG1BxVK8uQdzAjr3etU8eENRHUSsPz18lJ1DT+Gs5xBpBU1SYV5WQkSqsUQkwbHy
cdT5Mdqyv8Ljs1SakqYjjlNkc9mGiCROSAh73UhSsCJmV5xsVLrkSyOU2r8+1TwQuvevnYY8
XKbYCBUS-yYWK5D83+U1RWpSURXJg6yMSFy1bkpii4sqCTgZzSTaC6rkXS59E8TFJPHEy4KA
ATCOEMl+cw0kCSq5Vnap7nYRCQMdofOfiJqRqRKtLJrMpKLLqG5dKA8CFcgh-HoE-INnhtsv
ustBnv3t9tivd1sL85z9SEu2cLuoTkQ0-v-NLPK2Jp9Zud5YpOSrtnxEGkA23+++++U+FJNO
6L0Sp2Mb+E++t+2+++g+++-hRoFAOLBo9aFjNYqEIIz0A-G3rtTgjv+k2KDq+4k60X6NW2ds
88D0ZR2qPFTELqxDdx4LfyTQoxjSrDJ+bVFJL4z0c7R2MR-DKa2k+39M14c6rA4CU13k1nkU
a2-BcFuVNY+CD82q-kdU+Gm-NuEfe-ScJuUreC6UnmAGpjUaNpNA0l7vvtS0P8wWNfV7JWEK
bucFCrYqhyvAhGnz0iaKaVjxB6BdoVyHORrcA+W1xMH2oGxUmhHEvE8TnKefOXjPTjWj-p6M
KT4SIdUmtRhuDlPj2h4IF43NSGncWmRFdxqBwQvZLuoJRuyiCqth7vPbTHRy2YQrQPjZ9aML
bb7HOZ8Kd2XwB0ZdLZedWNjBvlmitg80ApoSQaMDWFxdFyVWZKYOQuPNWJiioHSjVTT6jU3E
GkA23+++++U+A3xP6JedtzR0+k++s+k+++Y+++-JPaZoAGtkMLCZJYhjqn+AjUT6Tx-VEB8h
A70ouG3-9wqX8B15I9jMMRV-gNZ2eqoNYdma4zPT7oelMwS7uvM3IYjYFp9wGB3CMuP6YzvL
4vJPvFO93MU3xE2reEHNPV5mUwI-Tt4bt+uYd2jE8zRJDWYKuhIsd38Wu3fENAJw3D3M0Mv8
4FSFTYkM1TZGbe8nu4JmmuHG9ZEkJU7FoQiAGiKl0AkNp4g0WDHEiYQiWMwViaNvUUd0PXYB
VgGvGdLWwQX8dViaxaID0QEqS2yfRfjA7B-tOkIy0u9ngUUDVeXGAJ2lLc5zTAIreAnKKtL9
FSIk9Zp1tR+un3YtLCOdLzK8e5sNDM2E32mXF9rSwk1YcE01ggaA0JYtr5Q-OwPHWjoxP0fM
KpepFzwLtHVMNgiPeLViD6QElKOl3GO0yl0Y+YkJlm5nbvgil+269BjwBzXed+937aU6nGjJ
26yZOUfJZKs6rOxJEnBHfuOQoAPEfC6BsRU6BR-2g1JJM8rwIl9rx8xjmWmKQ8D5mV72sI6B
WPjGn9Z8gBVSlmGROzSsojt5C+XKJC1KX65VRVkM-MiG20863JKAlmXtyyKFT5IagvhziBiR
qVctPxRz1YgKMnGqq5K9syA8+Xq1D720IGi6PEctD4xotl5K60E2EkjStecXaNF00IogNpE1
RuNuZN3FmOaqzHDeK+Xrp9-hWDvN5kly3PAp2x1lw77TYUudyyiAAcDySklgWUg-gBgWFLce
V5fhy+7oryUQkcLh73o+5BG-5RjCR+ByeWnrFT9mp0uvVGbjNC8gUQrkRZl3FKYg4TMKUYS6
vlsnsYZViiIoKSood6aiKS3pI874Rvn5BSZR4wtZTy02T2D4PVF2ob9nFcJfFoidV4TjeIWV
kzj5CxmSyqMNQk3X8a5PpcJCDc+chiwltX4fCdvDubUynZLRl0tlRTt-faeakQ2-I45em1Iz
mdDCmCCaDngDeIdGtOWBuhHquDa5i8hxtyPQyG4LFHQ551JykSJCxtCreSzv4FKVqsHTTxjA
dx0508dz+yT7qC-rT+r46+xuYEKpU4hE2udcLQ1OpzW-S6XzF9UrDkICVAlgDV4qxdDWE2X2
BkybbouvxFxEGkA23+++++U+AsJT6HgxXqB20++++0M+++g+++-hRoFAOLBo9aFjMypNLKkR
FlISzxG7vRmIoa-0+4bY0g81Mt4EhYG08YtBY2LQZhW77OdIafgvxxv-iniLaJZTfrW+weCy
Z+S2V8Vsc5b6GrZ+eN+8EWq3DU+De-IGsc2UIMaT-rtIThgUOjCRaJrT4xS8uuWWHL7DQivN
injbnDbPCSTujD1wPPwxTz5+WqkHrAC4qBfu8-jdiHREccSrAHNMTZxPLpyjPezrsPe0Js3f
7EsXTfSIwJnfKHC4SyD+DQ+OQ0zkpd+0v1PUI1zipmqQNVfz5CDgMmk1BOlUCs27N2kZmtwB
csDyzfDVwQbShQTrDnNksWQz48+ntTDZjGLgPZXANY2XZfCIGOz5usI1P50+Reloq7M-A+cQ
T4Ss5a1rMiSIhRbxfAsyTJKyfS1hC+JvzPYxFs05hZzmii3OxeyUCfzvQ5D0Tz5mvAI-TUTk
Hi-5UTQ+jkRw4SVE37s2fU5TXS8k05k4S-bs63vY3Z+-nkDThMilAw-LU7S-PXRXCT+z6RLy
3QV9UTkdY1w2IjMTZk9tJG0z0CHbUTkoYCQ0SGOEvkTmrI0y2wUHUJk6tD3+jVb6pkDtOW0D
-j668k34vbj7jlArllLPHz3N+LO+ew+j+5w1H5-6vY9VTnxk0TUZs6y-jkQSEHBktzXz6usr
6fmZsfyLrby8tEWffYOxZgRqomSR2C3nubPeyqtZiw5r0RzxISpZlzyqDUUuQdwqeIXw9s6V
7YO5qKhVYgoQzzjuSR07KRYESS9s+w86dV5h3Xydgwopjt9lki-aGRQ8uwTrPPzc7cA-JDyV
gH9Garerxy-XLYJ4KxpkT2aPaBwpzI2yeuAwZMULzGuMLu1viCJNzbbgmQxgiIoTre8EwoVY
***** END OF BLOCK 1 *****



*XX3402-050610-200797--72--85-06073------MWSORT.ZIP--2-OF-12
L8LhF37AiKh7rabdFD72KQRJlUKr8ajWlUBFGtUdfUojR40n8goHsGFLXbSIOz2qLiUYYEYh
kWCb1gI8MerGaIWsA2MIRfd4A3DLiSCdb8sh2GC2WOPYig4D5i3n-pDgqUtw2Zh0UIVmsJaY
OfMQ9uEkpWzAhAAHeCQoXnLsXAFK5KqKdqgbN0Fm8vpFeMlJd2WBhh2BOMBCZfT2WiGlhAvc
EgMw9K0NAIcOPUjfNAcPgALe3Dib8gA4YMchx6rtWb7oml7DLQQ3JnMvq3IaIF+gs27ro59R
mONfWpRFUzl7n528LuNkjJWKZjkVgc6jemm43nGTslpVSEPXOMQu30wEal+ZPvSHo7oIG2I4
pr4Fi7PCamoT6NobANVYleKk-IZcmOHhUn1b8Vz+hWE7xd0FA1+aFw69ghmST2ivsZ9kFFap
AVJVuvYYmG3-C4oUXwA0sy-EblSFHhitwomC5nvqsQBHDBLK7ELzoClovGEwb4Uw98B8iqls
2at0WIVHMeMsKdyfZX6Jht-BAkstoD4ts6lrFr0Bs0tD6E5Ob3F7Ij3HPZjm42LB03nA6JIV
9w5atAQ20EKz-z4wMLEOxcpUKhGOfb3SqzupiavUoUL7vbXqhEKvuUOerwax25e1ewDI-5f6
5fcRvACu5JJbf8TuApPG0du+reR-Dn1FvG0i-Tsw2TuyiJDs-jUKETyuIrjEUMqWRrf1adoP
1YunqnqRLy+9+eTiUXGesTwaCQUKWfGi2vO5os63TqunRzXJWuUzZhwbCzmoldb6ljqG4ODE
fQvXVA9vjmGGK4Ppr1Ffdr1Y0FYhGoAbaILdC57rvSv1Ru2cbQfXXadOjynX2hpiJhFeWqZb
xdGjYrEKNXcvN4GI4oh5zyE7vNlCnvEbiyJJC-nrR9fAGxCI0xeseJ+Tug9WfAEnCafeKWzn
aOGdXL6dbVLEjGuBUwZlIrNIF8Kh35tcEl9dYCNFWnQ2v2S-O6YUfejGKRU3-L-c9d-8-ItV
QDg8MexUgtcwotnWRJyYktdEcS0kdYFdkMZTnlI80hczeh2hrN2fs2SVwFp33e2UkM4sZehk
2IbkGuRfdrGH8UNCTqcYzC39JFnJCuIeIqviuojRuWFrYhNaIgMGhKWyeoscyCGvW9O0LmhS
y8lG4mo2ZqJrssgFrR-kX8481ADljxB0LSduAhMm3-NmLoAV4PX7An8BV08TmB80unV4ZMQo
9tPKNb9JUR4KTfTo6sQiYn75MfaWM+EtgIr7-mTG6lgYG65ciMuip9JHLhRI3839oFbQo4BC
JryTBSE0Z9sBnxBBvr5mFWArN59Z3JHcP2BXPllxiJ8bicmcvKbcrDFcd5fsEWwKAYOhCicg
e4R+cu9FvdkZ5sJmXNsDnExW8rlw6PK1Hh-fau9+ft0mAABvZT7k6zh1Qm-L-Ib-tcqEAc21
0aiJ6KbFDhJ3hBkFlfjK-vXV3t+rPJvr-Yq3CVuyQR3iyqsXB+jUAVFI8ugYVLzkk36q-pxa
4qqjHs6eZweEr6gCFlV3fpQr9DLETrexEmd-LdK9Z8qZ9dAb7aatHOZtvbZnEydhlH+nuRio
8WnoX6FsxzN8cIIYuMe3AtC6lom0A3IKxTjzTjzTvzxjljuTyjnOI7U-H7NnU8DZ9C+XDTC+
dweNk9z9iM+R1fC-WwBVDj1eQ7UF59UZn+YKmZb-oyKws7JmNj0dYH+riDmDjznllJzzwjaT
DTToIlSzTS3PXrrh8swwzBZQeyXQoWSjo51gnA0tMGNq1RQ5yhRjw1Jv9wKWqHD5SPmQtSnT
3SMtWyJAtyKSiMvRrNrhxAsC5Wvb-tT84Q9mO7UXX6m3KQ9vmbb0qP4hsjzcZnxLq9Ed5Xln
ztgGynryye4-fPvRiD2zKwtrjZXCS5tInbZyJwtu1cy5SQzFQiPHXRgDBlwZTRUlX7kPcYWw
ST2TzlxEGkA23+++++U+ocEy6cf4yF1g0U++C0Y+++g+++-hRoFAOLBo9b-VQvJOPKwPiF5y
5W1zUTpY4OQOZoBlVvDD-SkYjXDUi25gBWW8de-q8Mbp9WaELCZoETfPCnBwKSu99BaL6l7N
Gr84AwywQAXJtnxzVTPZtMjDv9vSj9aFpf3zg3Qbrv9bBC9noIXbV48n9Lj5XNC8TSFJ8RGg
AEjqugQTjnwtXAxfjRcOiJWulnVRJ-KXGNMNMMJNWz8YlyRy8Gq1TpR4W6zQWDr91lfliRKC
CK4RQ4kXrN8x2RJe8JwxVFrliLN5ZeqALghGZ6mXP3DWe-j5CBhkMvVmKuPbX8ghSt0ev8x-
TDud4xNMkGFECPPJXK3uck+BKlkeIy7HwmrlsedY7TW+YPD42Sgtc3Nhxn+YDdQUTiGZ+0g9
TmLeGe7hh5Zsb2bYQnp5WdsMq3Ars7k-CAP-w3Sm2bNABCGnryjrhxNzLihudNJEXdKWpUd2
sy+9n0p-ibdJWFe4i7BO2ME67NejctTJlj3N7JWdapapNNJI1y++3MNQMuJOg5T09AERHBhf
DkwI8rFHZSc6f+FC+giBQ2vGSJzXE-AoaPNwBYNvaCih3RLwuF2GyCG9CMGB+WKdlKOWs6XB
xR3OU8BPb4Qp49O+82xwb8llJ1f2N8sB6ETTbm+KwO3pYFOXjxM+VdXDNG5FWb8CFWexU-ZS
26eENXN9KGkHbs9v8+DYkCFfMPOge1HoCIoC+Dyp2IsKs7DPzY8ND22BQBq3VVmtfBZ8Kmj-
7EvKf7DEh69ZC9C2SgwBdlEl-JTS7oV6NZQ0p2lwE-BEFL09sTq9rUXcw-2v-xBAgwyRwbZt
y6C+dMk62ZKJ9XVd8dFi3YhKEwX+Gas7SScXS8fSK--9KDFQiy4fYy+zmXgBsNo0bUmsUjED
df3wHOV1PWWae760ra-YoWv7UuAE2N+PRcaxhl4ThyezCeEkn69Dq1SyNW7uyO7F483yYnv1
1Ua-NiOw21FeVLrtUf4vfTqvYlKUxPfW3Xddehii-6uyjxKEDAzNdrjwQcNRxu59W28P2bjO
dgGjPhfhKValNeSSoJZreCECIxsdkwmh3dpFcQeC68bOC6RU+XYbxmb35iDsmgUpd3XD+hQ8
MWk39uSStKTq0nlEkfrIniaOcEyif4V+5mGlt0BPw1Loh271P2V3aycPY7Gw1jbAW5XeKRsX
EMoSXK-1Mg6+YF+Ms5MpJnks4yO8l8-cXA42udyQ9jJ3xjqm0lPz1qHhB5bKSPeuYvw7kCwO
19gEtWnqEUW6AgutLWV6Bz5d+oMhNf7Ho2BLUeh6pOW0BWH23M07nlAyNPAUoj3dPuJ2MkG+
XpAaY2dKdps-U2HIdrRYrCDHL8brFVSWP+1yxlLssuK+h0pcdGYfsa81iNGUCz8AHo5xnvlH
k1tJ+-Po+5ZB3g20h0IrVMDRkggyiTXPFUZnafbJaQOA7tDEs00FtUpypRjy17-X7EnIMg2i
oeA3cE7ytsqpUIkikjS-x3+W0V03cqsvJTGHrhMfhmKb5ImsUdEt6SVNk9tjfdy3EsziFpv9
sZd-PSmid93iZ3BzNX1UMJCLiyHfHvrVStRz-lMUAIR5YA5ck0rYeR4-xt0hd4u4cBtcLZsN
LKABCQ4DKpu9rL9RkQtnfkyRbDkJLREiFRZr7kfcBaGXEzbiu39yeSy8DjlTslvNdzR1YHsw
xSa50GBEds3+btvv531tThwxFuS9GLuJcDUU3d+d8Q5EXhIdIbnTuCENT3KsFil9MKkbFzLa
ODeji65wynVPy5C6TWW93CteJBsht-c8VHKj4a2VMuScWFlCbd9hphmUK2dgge1C-MOFGFjc
QRstGxaGN+fxbq-jMcaI4autA1qaQSNrLCVNhHqsoI6D0YWRLboQyG-gIl4xLm117YAbva-S
ZZ9ACF+3V5-HmxBd1uKlj7dd9xJGcDiIrHHgkQ0x4oH9sNPJZB55YEhJ9Qe42wa+FtvEvx+X
d9sOuB1uiHYpHjdo2b1pkpZzE-QTgfL4tcRhDdxASrqzsn9j0BgxR5rfqTSSOST6bWXcsTa8
JxPvGkXYPZwAnekrC62rRBXE075B2g8Qv1rpIH5PyfxUuKkDH6OCaq3aJj7SZii3NuH8Zpbg
dvx4p+TSb6nS9lRnVdxCgjlBvMqoQ1MG2lkByHLtS-lfUulpiZNoDzpnf5s608dDsJniBdc+
63wTGES53Il7oShtGfP-4bEo0SeYW+lg6O3Ay8QHZ+LsyWxIwEcUr23n1z+AWQvmjCSf0AVv
Dhh3yvOPIaPSoO8YhFiQXGR8iwaJlO64LDDsa6dguWEmtioqpiwR+IMm09cioMMFoTU6DCgD
dk+AYpH5Ev9C3A4-g7oI5MKrbY8h36LL9TJt4+RU0en7KYzNWKKbRYj8RYgN5ms2JF+o-ujI
Ld6CIa05-+OtvXYvCgdlvFCEohuuUH1H4dLATMmlTiLIFy34ukSuTy4ooy13G5joiLBs7ASP
ltGgHrO+B3ez5UlHoVott-tr86mDOgZEoEw0l3eryG3mHYfB-nYWJBlFcovwVD-ZfIxu5HfU
yccMfyHae1mhBTI5HxWuTTl4CQNVTOmaHw82sWDPByBVBSmRV0d-oxYaIvdC4cEcukzYLJ7Z
UHJERINbWUusnp3slx5Y26oviiGeRkPyK+nkgDEJA-UxQyr5kCiKY-X3c7BIVlXg+CQ+18H5
U1M8DcSODia8IfEsrDNUKCq0MTEwyEU6wO7bbzOt9f2QT8vdIL3Gn6QtpRWMGObwTZn7D1Ba
qGIGdS6dP6oho9FSlNylL1VUXuyKEn3Q1uJswbcV9syjpv57QA3JCBczSR5gHa1DkUBBwROU
DHrB1NGwSB4w6pXrrX42kqGQQwekoABjt2zsQBbAtr1O4hZa9emJ0yJN-zcdWshsdsNxG9Uo
qb5oj7HrSmuygbiftyroLX5z+ONL8Zif3GxK4JZIxURHxTsOrtlod4uX7NlRviWKDs9gx4AE
vvaL0E1v4Qy3ppADkOJvYX+O1W9nvBdYS-MMZ0LtHJRiVq3hAr8mmiEzXnS+NyokjcMLM9+c
zR-QIMfCsOixGiXKWkDNgvis5O9H2S4D39lriRQHjixjfO2urYMLpem6tEbTsKWDrqgb1Laj
VWV6WZZvGAaCCoJjvWnjlNBDBdSr5C8gS1v83K9djORzsITrXpWaIxYwqu5Pu1pw07pWt6c9
1fnxAn9RSwH0WVuCqIxkRDEjuQGjQZ1SMobj7qMpzGloLaH3j-miVe7az8DtSrv4DMOetxv-
EP8HI6yiG9Pk9RvdnDebIA+fu71pXHX8QPtwrzzSsHidy4fMu+PyvYdqyQgEA+znv2qXwXRA
Qgdioti8r4erdySjO6MF8mW7j2Xt-JN5jLnGw-O9Z-zdEpbCWKTeEWh+xlaR70L6U-bxBeI3
Hk6TMTJgeT0BTTAeAEia65thVFLY4FWXekDPgK0flqmsM6hEheMTU7amMdB6-6LUAEAJ8FEi
qgmRgMdlBciRUIKwO2Y8FoYmVZvO+JgkuiorhzHUaSrYpIwHznikTEaPAdvrYtziq6mxOvN5
ywlTcvLUvkZlrDzGSrTvsUCbztCkUljFro1KsO7sUBrO4LlHnfvvMHwdBO9zsRLrTzaCrHHZ
FWvgAxPzKNUOroIzcl5xvqV2TxQgVAJoWfxteO3KLhCP4IjNiA+nKDM9B5epjV2JzUMazEm3
ekR9MSrA3fqWrV9RUPzjipgWHzdl439xOGxJqvvwTjztDp-9+E6m0lE++++6++ZqK05egMWE
Tk+++9U0+++9++++++++++++6+0qUE++++-BRoFAOLBo9aFXQZ-9+E6m0lE++++6+2lTKm5h
MvjVxU6++5+5+++7++++++++++2+6+0qUOU+++-JPaZoAGtYNapEGk20AUgI++++0++EMJgV
82W873o-++-g+k++1++++++++++++0++hc53+k++I57jOaJXR12iQaJnI2g-+X693+++++U+
CsxM6O-wFBGL++++qE++++k++++++++++E+U+9O-H+I++3-mPqdZMrEl9aFkQZ-9+E6m0lE+
***** END OF BLOCK 2 *****



*XX3402-050610-200797--72--85-52520------MWSORT.ZIP--3-OF-12
+++6+-NVKm2PewD+7k2++CE-+++A++++++++++2+6+0qUEo4++-EQaxeNKBoAGtYPqNEGk20
AUgI++++0++uT3QVBo-2lNU0+++C-k++0k+++++++++-+0++hc3S-k++HLRYP4ZnR0tnQ4BE
Gk20AUgI++++0+-3JZcVQ7vIFWQ-++1Y+E++0k+++++++++-+0++hc2T0U++PLR2H4ZnR0tY
PqNEGk20AUgI++++0++kLpgVKebbxo61++1U1+++0E+++++++++-+0++hc3j0k++JKtdR12i
Q43nI2g-+X693+++++U+AsJT6HgxXqB20++++0M+++g++++++++++E+U+9O-q+s++4prF2ld
QrEiN4xXI2g-+X693+++++U+ocEy6cf4yF1g0U++C0Y+++g++++++++++E+U+9O-FFQ++4pr
F2ldQrEiQ43nI2g3-U+++++8++c+CE6++3cW+++++3-9+kEI++++0+1KWD6WfBNHY46-+++r
+U++0U+++37ZMKFhNGtoS5FxYQ3Ckn+AViyJyUvSONQlgM4MRi+kgM44Bd1M2C9chJsPhIoa
CpbdqyCI+oUUQabXrvzxqRYWSqDV1SiQv03k+TyQFvE-iMCfGpyCMH8Tnx7YUnN5mWdWwMkW
-3CBnWMrppDMV9kpVQGmOT7+r81hoWFBxeIFC43KMI4ECSjFK+3TAV4QhN-lSbJ5q-6Lh5Dg
Fk1CIUntYi06sYYwW6jg-Gnekf5lNEAb7q6CBMrHN6JNqNigglRAKR0mNzIu-Z3HHO1UY9hk
e1icXOocpsxs4TK0Y67UrSQja94HQSGaDllxThDS8xLSB3eLsp1BGNhP5qpdgWhXg5C-JQZd
A-X2u58xixggphjJGtfQzXWzJeGzCRK8nxcGFSwXc6wHYsWWh1eu0sc-9GedxJpQZ8sO8aBn
vTzi+UFx48Atzcj0hFPMG8LewjZdi6TLrGfetVVp5R6CBPa61y8R9Zo7jabJx+ZEGkA20U++
++++X3u66PnrboDl1k++wEw+++k+++-hRpBdPaRgNGtuOL-EGkA23+++++U+F3u66SWNFt-k
-k++DFc+++k+++-hRpBBIqxmR0tkMLChKKpjqoMGzVsUzq4yKINJkGu83fKW+eYH3o2HLJ0v
3xkL+ohl74pB9MLZIeciiDxyAvCvt78W6wQ62JXYvCmwDDCqN1tzzkqizvpwwFbiPXzQZhP-
jy3mQU5DiYHC7uiREkDN+HscuvG-Huf6oKGpLQ5Z9vzwB5aObChmSv-uhLNTYjGu820M8f-M
cRpVDib7iJjf0iXTXILwd0mSJbxoWNltuQ-VtR1-LfgpjA3WixOLLmBCt9lnNlJgPPbHCSOU
q9OlG0lf-kfqmZdZr+587GVnU+RhwfsCYTCTgcOuEh0omw4Vf0qISoBcJ6ibqhH6qOW1m36a
VplLniegRW7uGOUJVlA0FQtjN5uINEWfWbspymeavIjvQB6gXwyGRzHAMAeafZk21VE3zYML
K+o7NHabgzvopSNDXdjGY248AU1QaanOP+jQc558uR66Q+kU-koe8WCJ3EWJBWjuwLsJqXlE
k+jmWpVd-S+1qVJmoHolM09bfTav1AVmQ7uFnhwGbtQjOYDlqSlxxtUmFFi5ReYK8AgJJWxT
+BkSefyQ9WXLfkhJ2J3MrK49jDfljHM6AvXbrmZH+g5WcfEt2xf9s1zimayNRZQSw2-zfs-H
lukuWqXmXgOvO16dKP-3cvhzNLzXkdrnuhPe5QLO0q-3MryvFdK5qoJh9QKzOwXBfTsjYU5j
066JqcN8SX-ij5arAeL38wX8gY-Z6ZBh3d79pyJaGrq8dJOXEcqVm0-cCHwK5LR79crI-P4f
mfoSkoS9ivgm9yS2JfCzNqpbAlgt8ZVfN7yG9PJlfR7nS2H+hIK0WpR4tWfgpEsrJvQGWTCf
RVRJg0CMIM8ufPB09k8UIa5pkdIqm+hOQancPzWqD2n95Jd9TG-kT9HZ3WopnKWjxjNGyeUw
-4JDQkb1TPhhULZhYNgtCc8DfMlMDQ9oRfBp-kZC5sHToL20xh8jrTwunoQ00UFIXXUyY3wr
qZNiQ6IXSPHkjZHtXGorr+l5z4SiBjWsVZipkvjmeQmycYCMeXLaDPVxLYCHmV3jHsu6yuRy
e5kJL8g8XzPvdPUzDB5yKADRtggICH-6nZ1zZRMVAreZRrEGqOaWlceOJFCddjUbHovQbP9g
UA3xYWB2nr0ZHJUNhLYHyKPE79tM3CXrY7TEP7J9ihcAX0vOjYLdF0GqFqXSTpvs2uiu25Mj
9k2bUM65ZQkPINrXIh4a++QDUPHWyd0YfaanFct3bhMZho6m6+JE3qAsWyQhJgswDDXkn8AG
SyNAJcEY-Ia2Wz+YmI9DBuecj89M9qRkNyiydu2VW9Pxad765-vv5801czmGeoYDOHqBrGFl
pKx61GGlJ0WSzidLXgxlv-coYhscJmfhTd6Ig3ljR9Ih8lnlOeWy7gFlfIqdBUehrNqUyvYV
I5+TcfC6qtRWUYFv8DiTCae0irEqWyIM6gHO-6Qa6sBAeVyGS1wVGpWgrB-cFRcnl5t5o-nn
7lty1iqLuhhLRMlgquvGk+uqwnNcSUYXCeGCPWcS-tFxtySB7rFpclimxbsGGZH2yeQqaX3S
8doRkABfsPIoBCzFYJz6QuKBpiBiRENEMqZrRDWQ3FS1xG0hVRnAGqx5loT0cz4GQqQ4NqQd
62SMgAQSt9+jQNYxV-VcTzL4Jly0Dt4uvOt7qqUmCnZVA7P5eSi5PNlRbS04tC8uGtreOBG4
rVOx-Z-9CewqGfbPXiYhtU3XQqqKm79hE3W4tbdWHNU1zIP7Cm7czEl9qYXPAVCWBYZGdHp+
n3tm4jUqHtly+dlk6QqSlDGseyZU6SRP5+BCznl1LwW5MLIRF-8B+orgOoyyMN7Hhwj4g0-u
cPiHL54BLmE3bZrBF5F0GUdAIPJYJ3Xw1WW2X+Wd1LtPs5VRJLdZA-xZgFEH+8UACmqNPHm5
JxGTYa9g388uu-gfp4BWhmMvAVP2bHJvArvemvhcIbAlzP9eFRga4pc0LYQJiRi73IYLDvpt
bHLO7p8amG2ctYEvBNidYavhZAVXyTCJ9nwVVpWBZ+qHlt1Yc8pBtppdDcMtFLCS1MpJKiOQ
jokmOkujUjviMID2EySQq12Wx6bsPW7an9cgMQbfOR8FCAyD1XNTqAvltnJWaTPMuOSL35D3
x6jaCJEDYJz-j3QLUsM+UPMUzbH8B30Y7bn-W1NlEC6kN31qZENZeI2Ra7tdq60InJ-zOnWW
+MYEGOPtRzBdKVfdJCn5gqrbhovFJCEDKDm-ud3XG5UhP6wSHE57tl4ThyZY4V7mwfopZ3XY
iE6y6j8RiAADjxL97ReV6s0DbFQRxcwV8j46wSRWpukyybfW2sCzNvshZmrvw0a8rps9YuVg
fKnnV2w9lzEMdii01d2Rkow-SS8BDg1cCNs9chxx184wcMRJHlguVX7ujKDcA5u7DHDyaj85
5BfwaeUWQ8AdEx+CbX7HH3h9qsZ+RlB7zhDTCoxTwcLqu1wfq6Xrp3AI9VvEwaTYWhuQTjWN
uHxTzjHX1z0ynjRuJILarx3iZ1bkvSqOrybY4zdpaSArzLHvTp-9+kEI++++0+-mW5YVrW5s
fpw-++0K+U++0E+++3JiOLEl9aFaPMKGDov1A-X35HhzO28Y9UlZuU2EOiYB86p+I36FGpo7
XRhO75PZ49JQU6qnA5+7Xc9M47U-qu3dZv7wgjKxxxDHgvxxU8DsNhU3bSMH-+0Dccu96mu8
feCbTIKa2fo-VDY0GaRAAnZ5ftNvHiVg9h4FtTLHVOGQiIPjFtn7snvDiT1q7zaMgckjAJb7
E0yA1LspxCou9MUP1dBqYf8mbF--dwOTmASQ-0+QoFL7ml2F3qkmVvSy+ZK625Xsx238ndl2
dY9ec90hQluObD0mWUZPRIchrgDdLGkm6W1kMhPDuSHSwzJ4bw4OPExKp8-FlzeDfQIpqZeX
4qdFYFowm8Vop11ZkdPa1ehiarzRkcAO-PRw7tiyMdQDqOclpvWq49oB-bc4im1q-eE5E61X
-K3bBArt98WDrH0WCJ2OzLWSCmrJlLHrcjwDSUT8LWmXh7GM3gFFczdWboPmwGg-Dp-9+kEI
++++0++MaLYV82W873o-++-g+k++1++++3-mPqdZMrEl9b7ZQuJHgIv1A-+xBtLG9eF6v5FY
N4grE2kAk0ykc17KEaewMOZ1D97OKTWB86gzdGBXd+tVe5fQCLLW37VsxcjnvhvNHaE1+2m7
W+qDwHbkyMUcL4kmWMQyTr4cjmM8C6E5w+SIuu-IAr0X3qghXFl-prYXPi1axYKDIOpL8pbf
drcqNmjdlS8ZpghCzmSjDFFf1Jb8w3fym6B4toVRDIycIPNtxv2Im38dhb9RO+uYKH99x-lw
E0yrQXbm-UdEadPp-e1epmUOGKxEgwnt9fo-l0aXZK+8OWPIFJsIfFnbFKZ82qWH4lDeb-pR
DKjn5aVHZ5YbMKluOJekv4gmE+zXM5O5MxofDq+1YDl4GYKS3W0i89MXoca7oMcpJW-kBzX+
LJ9VbgyGXFeeU1Ma7cWPQwG8y5K3i0QWwsq6NvE+zrH22vW54vW1-y6hDB9c2Rs9jUo0dhDV
Axw8jYI0jU3EGkA23+++++U+Grhn6PpOmxW6++++j+++++k+++-EQaxeNKBoAGtYQ56f8AdD
9ofAJEUcmgx8HGslhCPZsiIe9IshtiJGI5199wchpU4lEjAmGkkJAjAIpA2gjM92MbK3Od0w
MGpMGvJ8Y68KLd-fQ0q6ZtGObdY5oiRMI70HaNlMYdaTdyQ7p7aNa7BNZKeB9iJQZ7dMYUcm
HWA2P8UCq4t1HEmJEOJtE95Ij-ExLWs+I2g1--E++++6+AqVSG3KHcbs7k2++CE-+++A++++
I57jOaJXR12iN4xaHN--Iw6k26LjbSZzcIB358Q5c2JEY2d-J6N18-3KGd77oU5xxSOZCbft
yhvPP99RxI0S33JQPw8UZoFVo+Q4GGgAIW+1Vg+R0WBU15gDxE+p+OP+6v6NY+BDmCN++GmE
9O4SUFLkUikJuUqeCAXnW6EpjgaN3RC0lBvvdG1PesUNPd6JWQKbOgFCbgqhyyNOZbx-ieLa
F1zBM7feXwaoPbEMVA3uEi9c3n-ZOiVqUQRahJKpbKozzBA18MmgS2wdH7bmPPoTWrTdTtl2
MJZt9CW97p4brMplnyJTpcevJxQRhvMHqzCy4ny7ctisrL65gkhDiGYp8IhG75uOZ1EjfRH2
nSNr1dStMg4N9UwtgsT2XvEXR958B6otoyn29RTcaxT0SxGy+J-9+kEI++++0+0YW5YVK9aD
0fE-++-4-+++0E+++3JiOLEl9b-VQtpGkIv1A+mxHxczt612E8DGsAP2VMtmMM-c2SSgBGCE
7Z5WXW52jlCv5FgOqs392vxbyvqsPcl0wFUzcr4zpywdUy0TNEYIB+30jmT2Yn8JTEx1AMIE
t-nW9Tw6XuVoj8JOVY1EhNTiFNI2KMDS2dZNLwRXceGqwn0YNXZK8LcWuzRwaZiDRAhYk29J
k0Pkkk4Z3ZEy2VSW76o-VoR2I-TdwJkIZkqWBSAKj3ee9SnCUKbZFt3OFlpBaYHwQg0xeXWG
GB0t+NpiEqSz6SRh0JLXUSqYKdJjUllA-NvoNuxEsh3K8XxbHuvnOW2Fqf7DQRy47lBsox79
JBO+2JyQqQlWatx2Xjv8WmcwusLo3D8Ynvi7hthECkop4CEmEXsD5gFlAgaaLlGhnPR3mRvb
na0i1+aZqUOOwIdzewryILFqsk92lK3ihIKP6VptgKOHp2CQ4+xHDKxiFTEBNMAUw+Ksa3SW
hH3SBohif8kmPyhAOFVgpVBk8qhczxGeqXcCSMqG+dN6PdWvoh63e5tqPMRSxuMzCtvyfuBQ
E45Nzy3RUuv--7RsiBDrqHuJpTy9Nx9jTEBEGk20AUgI++++0+-2LcUVu7Z5Y5+5+++x4U++
***** END OF BLOCK 3 *****



*XX3402-050610-200797--72--85-51937------MWSORT.ZIP--4-OF-12
1++++++++++-+0++hc2+++++PLRHHJBjQbEiQ43nI2g-+X693+++++U+QcVt6RsVy8xT+E++
ZU6+++Y++++++++++++U+9O-aUQ++3JiOLEl9aFaPJ-9+E6m0lE++++6+-WNSG2cG6cYLE2+
+4k1+++A++++++++++++6+0qUG+7++-EQaxeNKBoAGtmNLBEGk20AUgI++++0+-9SrAVjJf9
q6U+++0w++++1++++++++++-+0++hc4b0U++I57jOaJXR12iN5-mI2g-+X693+++++U+nO3t
6JNCWTUb+E++t+2+++k++++++++++E+U+9O-KEg++3-mPqdZMrEl9aFjNZ-9+E6m0lE++++6
+8G6SG3MiMw8h+2++2M2+++7++++++++++2+6+0qUOcA++-JPaZoAGtkMLBEGkI4++++++M+
-U-K+E++VEs+++++I2g1-+c++++++2hRW03V9lqmg+I++9+3+++C++++PLR4MLBoJ4ZhNGtu
OL-EGkA23+++++U+9d3M6OZKPkVB+E++l+I+++s+++-hRoNVQrFIOKpZ9aFXQgKHDIs1AF03
LlMYe2WCEAY-C+-620Y3B2HW0VlXGrRQOMym-EIJqX8RaHxv7htB+F7WRWrjtra7lnwD+8ud
tOmhXQyitAycfKFggvYs9zYPyzoRhFJoiCxk6bdtoTTOwIATkn-EnmBNLWt2CbuYfcmjLwFc
gnNM-f1CWS6xsofHqLV0sEBlBaNxtfHdHJ1H6a0qh+W67uwROy8ONg2VHL3di2kVHE9WU1Bi
x0BGucC+oWY6C-o3YbO-dZr+utLkzR5kzMbQuaTvrNv5Xk9z54xodqz-Rv515YxslFPrS85j
DLP2XuNPwUOrsUrwUHQSabUyrfeD7FthJiC0DA+QjI3wt+rXuUrHJqzczvYrN9vU1NizSYDf
QqwcinSgzbfLXOgLHb0XRqzMTBIPJYyxyZejSoDLsxscumprrTOXSa4-KzpgjxjnW15Xxfmz
+J-9+kEI++++0+1cM3gVZgdJabo1++0-0k++1U+++4prFa3nR3FdPKIiQ43nfJPPPVAl25qD
Z5wM5Z-G8MGY60uBS6-0c38-EU6JEXksitCBpJpv4RhRJZLtRgNCghaa1EYhcpnqAbDaRXnq
lMDz67TBlUKAgq6cX-r91C2fx9gxi6o2e3CGpe80GEbj-Jads3GYAOe7ckHuntwzuSu4QuXn
YaEmgrx1Sdaa27EA2-eYQsmvOnXXaHH+bm2VbUf0vSujGQ+tgWo1CSZn4KAAkaBqc7-qddo3
+MIU2geKc8QUJ+ZbIgLffU9CByr+4EH7JVN8vEVocHU92yoOKcKHWH7U0FJ196oZCL2qE2wt
qvHQ+VVkLb5sGmmZ9FXyZnvL23eVuSnj62iQcuarK+j1DwaQgQj0US041KK8tePEDAtqkauL
FPzUdoCGO9UvvtUXw-aBHdqJKX4tb976cLzwCWSAdD2jTDQajeBJLfpCfxRvxUUm1bac0T0L
7Qmsi4-aaWlMLXA4v+kx+ppeEm2b03CFQaTyRptCQJJLWrLEP1EPoeQm3F5u4uO1OHPUZCab
0qPce1FTf2ntuX+JVZym0HEPhglN5Osgz-QESNLqy3-biJOcv7tLmIaS0lio+O6Ce1tzxkxU
T0kckGBqbW+Btey5Pp8F4sk1rU4AT6J4n+SJ1CNEqa7YAEsrPd98O+4f3RD4FNM9T2X6vhcj
DlM8uO+Kn20T6l4nOC2glgfahPzItPf40SYQWFTZlf0sOG8y2jP8BA9M2Q96wj0tsObC-pIO
NXPDeSPmUwWiVH2KjUucsh0rj+9vX+Yjap13oB+gHtZWmUdDJjzYsjSCQfYFSA8LmgSnT3MJ
pfFPKR5eT8xlsQRS3GS2nvw3I4xb1PKviPKpy8GOwP7ZYZlZkhuWa4gQSk4hpdpWfP4c5ieG
IHQ4hbdtSvwf8hLR9gZKCTr2AukwsTKh8FAeEhv4S8mde4l5wseg8ml4KpjpJnrwRkdhWWuE
TaBkZSzxSKnpJb4bUddhhoP6-6bB+RlDKVrsnifRHov27tkuDC1tIhrhDMGcieZlYbyv6OTh
ArCnVCZyzK0lgkHvMxtu-INbGAk6DpxVzyZqom1-zabzmSBxC5Nl6FBn0zxjoJSyr8txLM9x
5GHMXpn0Os4b34wkD9NsZky1msEXGOFtluyRVs0DLp-U4aZSiQjHaJ-blXA197Jy64RZgBjl
Z1WOSQlkJD3KxvNOfSGiin9Pzk3EGk20AUgI++++0++iYJUVeJNj02o-++12-E++1U++++++
+++++0++hc2+++++PLR4MLBoJ4ZhNGtYMr7EGk20AUgI++++0+1cM3gVZgdJabo1++0-0k++
1U+++++++++-+0++hc3t+E++PLR4MLBoJ4ZhNGtkMLBEGkI4++++++6++U-s++++6UI+++++
I2g1-+c++++++0G8vm7UxzVBKkU++3g6+++9++++IatYJ4JsR0tuOL-EGkA23+++++U+nM6c
6j0HxWDo++++K+2+++c+++-GNK3YPKIiR5Vo7N--OwAk16LjUTk5tRF988mAxHnM46Dih6ql
cpj9WJT58d9QBDxyQUCm-T9rS5fy4eC+ZMA-Av7HMUVqq4JD2uGMIM+08BtoqnPTUe4YCu2c
4jA+EbnjnqYUXXe7MSyu2PUkLOB51usux60r0uB6Ka0CCZ7FAtoRatAipQ9Z-QslSxDzIc2W
0B2MVMI8+woNCAf7LZwcPlGCmIo6JbX3113I47r8WaASPDIS7fhfja1Rd8ztXtPSIBgjABPF
tyUMJx47D5NRpnNhwy3e8jVlmKAy3VvOta-Tsj-oFVPZ9SnqPPBzS5fQkO5sCEumIaz6YmLt
-p-9+kEI++++0+1fWSwW3yR8rAo-++-M+k++0k+++37iN3JiOLEiN4NhVN9-PhEk26OxGHPd
PVdF1VnUEbU-Z3kEtmsBKv5PLHKKSY90qHWBJQSi59SY3tubTEbCD+8Dk+hkVhWCBm+eYMDZ
mQlwzwlsTgo-n1PbulEYFogL+9XB2VxaL1HdJ7zS0ZTGzENQm8wRCPoUdOnRtQFTMb7NGzQf
0-PcKV9Cz7TjAQA0GRn4Z91yt3IQ0wF8rgEGRr8SQGNT9nXZ6XXQoEjGSnv1rV3eVk2uDqTO
CYABxeBp5iS6hL4C-OZATWvj8+t-h0IRdioKWpCqetpDQkIO2-5ksEcJa6Ooc4QrHM53dh7x
C8xo4pxA4wvOhlbv7duMS3LvGXI-94jKgpOMxR3a6UzU9xHPTp4V+gEeFxM+-D1sFYfC1Uf7
Qca2kHWldfkM8-wgtTaSAhL--l+J4p3WsM-UklOIv8u0m78oCGc2zTyHXUlpTUTzIz-Iw0Uk
qEgQ1e0-DsIb7N35i7FqdeQGByqTUzose5FKtRb6RHnpF9uL7YZWMJ2DIpBuN9+KRTQ6mXIc
7ro1k+kiOfmvCiPRn3u4bPorcCI+EVPoRBxtR4uqYycr4jYS+05AoGpyFl1ZZy3sHOCAI8l8
prgMy3Kf10AMH7GUykDorqxEGkA23+++++U+266c6WZcPSy6++++jk++++g+++-GPaFINLVo
9aFkQWgcmYwjGglJ0Ad90Iah895atS9Z8WpC9SPZIZ-kmmz89RM-gM0mcLaN7EeNSEfeI9NS
EK8liY6pG6pV9JVPhIeEUdNSY4hk9MWLZ7eSaETGupVEY7CNb3WGaNybtkbIa7aMYpaJOcoi
tJmIaZWG0X7C6kFge+vMTYBB17J-dLZ+gRGw31pS9U-EGkA23+++++U+wN9g6ZfkDMhq+k++
q+U+++g+++-GPaFJPaZo9b-VQupJPKwWBl1yXgFz48aJU1NN-Oab7iFG8ET7WGUjdw+pOYzr
kPgvU-ijXKljkXOuzxsNvliooL4huUygDGzDX1rD10y5zwDuoiqwk9pCtvXlw0gAcm5wdlJk
5eno5XL2-Rk6uuK4-u3Gp53iZn+wCTYtyXOQ1ocYa66rs3Q65z7MmEEa7VBGvoQcJw0tBFsw
CcwSbeJTkEHJSWK5rsf-8y-ATQz-qdcbaJ7Okc3o-k5Ft-s2D+hfVTM3a+I6LQ0XpCbTMkGQ
rokCiICEtCKVA9Y3wun-GdTwerglHWO8U0Jo0eZorgcsxk3uMF3JgESEQTOnMzwWb4sbplGK
GDGFjeQgYBeXLJ+FUxOVurM+5iVNn1Cxr+ou7tN6ipbVDbedO1RKkXYKjPS0OdGkm4Vj1Ggj
XQrcAt30aOIvM90NHwTS8VT0yK8B97mnsF1C644oTXUCK+2ESnrnlAYFnBzZrVhxqgUjBj6T
MYnxPNv3OCwKIsyN6zp34Wv5qdZskX8N6GbOIyhw9HJScpuiz8ubWZKBGsdf2OBeBMr1hbmw
kiHlbRZkd5dTeMWFp0OtlSNqMqeIlzsARMeKvCzWDn1lUxTAyR7TgJtPyGEwZcu9L0RS4goZ
bV5Fx57ITYfHo7uZtIjJf6QHT3H00jOWST03hFEa3Ch7K1u4IcqeYdKYmRM8AxEyi95YtThv
y04OLBs2ZXJdZ1vF8xZIq3Q5E4wt+ePV2ap6IslLUav7jy5AarDeqq62r9v3duAcyibctApb
vi988gOZp4nAO4T2CHgrIyrvCkKCS5GKfmMLPPaWgCAdhg8+oM1JQ1EnIdDpuJ-LWDnd-4zV
C5VJRgSbvTBFAMm38m1l2Qx5BXwQEaceBfQl+0miITXu3CvDTiCJvJSVrlkDs2SsgqazRxsP
p3Y+t7eO2jeZmxgnuDrS4k13fGGzY2HoKjDa8HxRTOM+cbbXBihh6weNnPsveXHru59ZEqOJ
0GZehbEv9KqfiiwZSwI0ajhfq0L-r3l8VKFA7SBR2Bu6nMI8DHthH7i5b0uqinquq410MzOJ
cdsv7tSOIThZa6ARHtPQWUk5nOrtrv8q5SnIiAZcZrAv2qa9RjSVaj7DP+VGLjoAVgmF4epW
mEt5EUt8BlYrDJKZKKQoJgPVpho4KmJufI-T5GxB-UaXPW5FBydqzU7EGk20AUgI++++0+1B
UWUWw7Dq6zE+++-M+E++0U+++++++++-+0++hc2+++++IaJVN4pZ9bFsR3-9+E6m0lE++++6
+Ci7vm6LtofQnE2++3U1+++9++++++++++2+6+0qUFk-++-GPaFJPaZo9aFaPJ-9+E6m0lE+
+++6+-00806dO4rjW++++9w++++9++++++++++2+6+0qUF61++-GPaFINLVo9aFkQZ-9+E6m
0lE++++6+D4Gv07Ow1q9RUA++BU6+++9++++++++++2+6+0qUQA1++-GPaFJPaZo9b-VQp-9
-EM+++++-++2+CA+++-W-k++++-EGkA20U++++++EsTm6bp+79t-Tk++ELw+++g+++-hRo3m
Qa3t9bddQ3-9+kEI++++0+0CdhEWtek0Lsk+++13++++1k+++2FZPKxEQaxeNKBo9aFkQWgc
mYwjGglJQ2bBnEwcmgx8HGultiLWtGchHWratJ7EQAgjmWrK+P3+8Y9nAYgIAjAIp42QjM92
MbK3Od+ekpeklaeJ6+IhjG1Ls3cE9mYpDHADdBilc0+bAnal71AzHwwHe12nAGSn8hIOLQet
81Kl7-JYb2M6q3+Rg+gABH3I-dLa+QJGwp9oS9Y+I2g1--E++++6+AlhoW6LG-fjxE+++9Q-
+++F++++PLREEqVVQZBoQaJVPGtkMLBhI2pfkn+AjETm5kGvh318RYr6MMGmom+g5HivXfc6
2hjMwcPruyQD3felWsrSSrduYZT2g5sCzGngm-P3qhNJLN3Wh3QVAFLScOgfU14sJuP35O-T
V6hUZb6kaBXn61QDu2+amSvwX8iqcO1v71CKDUHb1c0fJt778rV0TbEtF7DThYUpcqGQQi2j
0wbG3Ua1ZUDokUV75Bczy0wjW9CbakbhNiTascpe8ZijNg2J3MgI8W3PkBjhXjyYZJctnaSM
wOGa-j9Y1ivi6rb-Rp8759GXNBRoAB6LtWFjZVVrdSo+1zgAje1n0oRNiJz2TX94zpVLrp-9
***** END OF BLOCK 4 *****



*XX3402-050610-200797--72--85-22789------MWSORT.ZIP--5-OF-12
+kEI++++0+0kcxEWPKid5SE8++0W6k++1k+++4prI2BcML7HPr7o9b-VQuoOOKzPmDLv+jYD
1xY0ZROm8hbd7d5W+77RPkn2FqAbFa2sk6UOGPCaCCeEh8CuyxzvrZkQ5d8RPcF3HAuwSxst
rASRrFzqqrbl2zkL1iJm7FCSN+A+i9csL1-p8JJaxVFb4NzG1g1PprdhZ4Q9eQkGb18JWEGi
KHnZmGFLQohmhJNWjgU6dDzqvSgCg1U4jNG0sWZLxrnOpP-5D6qIK4J07UAUlWYkiAmEwF6S
F9M+9J3eU9xkZKd+HPWvdlQjAtHFmUD5WjBfdXXiz2V9zM5o5i36d35Al78f+PuXhFMW-Tlj
dSGxaD6dA5fh+DyqEWLHS8opY5a48XokdJWGfI5CU0Jfi-C7hU1+jqECSQd-63U4OtYfY+w7
KWiBigXrlIxtUZj9-rwoEpdwzAibLPrvsWSFN3nBKAEpQAdHi3mbbnAFcmXLm2MysACFM94Q
dlcrKuwo98dI51WUOaY8d0ZQuBIFGfm4+zVuJPkCOTieh2q8fKxurKvjZdHHSk2MoGMTkoB-
s3aSF5HKo1f7y99T+TenBn-MvE4Qc0tnLgJ5F0pRuydwwXiDgXNhftGsltDLBcFX-BA0RS08
9pTqwT8-aQR-eB9EcVn8b9kyN+YkCqEf3cZgDOWgbuDvWaFEe2QGm6VDQpHg5xxK97bKZWxt
tgWpnjV1ZLHPoLN4yMpbJz8C7uqHNAezSR5O7OsVx6JA-HrL20f0-mUTSH9D3YwU30eQQXLb
9SEnuU1yCxPzTaFdBj7Dsk3wZAYQ8EkdUipV1yfbLxALpmShrzDZ8VLzsPrW88dYDdH714+W
NQlNAXFy61Do0HuhuofCZKspNiagag05c3rISOXVa2xW2FY0YInGHCJF7VJ2CZpOmZDipszc
IOu56CytIdUdebMMHOShYAj4ox1SUPNe4Kywm7F34J6OJBvP0apf7+vFQ5L03mmuemryAlTF
5FayhTowadqa0P5N5k9Vo026sDfN53RQMJ8hFVMK4HMhMVYSZAV8sJUXIAc3-hoYW0eYRd8P
gdDQqZAkSAvl0evuRMUiAKBtL8AMNVMfi3am-ClP3IrvEYqEgVkOdcfcYYMBhuFxY3qe-2k8
SF9RU-IFYmtAX58R8P3i9JQlLq9bkMW79adVnhTJ9EmjMezf6qr0oH72J0E9HhOOqeM3xlmT
65k80WsAD+3P1UuUBnGjneLQmWSCHMmAHjam3JGP5jk0ZlWFtvCKWRpqk1b6+E3fZks0tYJE
bbUx0f0hWjXGssa3JQSf+HjEvyqxOXx3vVYZ8n-NMOA+Rcip0b4qKAqblI0g9FbGWzC7dlVR
UA62YGhaPjoUs7shS-6KPGzWXE4y7Gf2ntt7p16Ybl9nmNfH78nbfN3ibr30nmhIlHZJC-Gu
PKJYOo6UQjCFYa4yxnmTosXQAuKZ3mfBY6x6K1m+aW5pRfANkG6R400xwf+EAHTfLy5RSzWt
jkxHWSY1XtUKqwDWR1EWfg4i7z02Hgzclo8hjZSRE0m26f3wOLV0gCphNPBAM2cAbZCtGKNu
SJ+ozexuPrzJjTxr8SC75pHPIbA4C+Fyd2amNTVpb0Asj5MUn6pP7BzyqSJfOmnaei-KPzyz
KWhfC+rEUIxtob0WPb6s+2xtK2rH7EvK-LB0CEtejr5R3atw-LHQLVgRZxMx7mg6cW5Ao8lE
shGffaSeIw2YOBxBD--RbTBkfEY99Rl5B0lelLg1Yf4qgzYXX3a8JEoxYo2WYpr3clmbyTiU
nMGNYYj8nL-tDTdhRuGW-Svf8PY3JpzoxM-6tj0N-i974gM84spf2QS0MPTJdcuVwKUrxf49
KZS7-sfhnMkCYqsfQ6HA7quMn0Ra-lzotg-BDQN2B5TWH0Hi7QKE3CUZfgz4+sXik2JAjxjR
rxDlUXOEOicQaqMd04MdLWbfJV8e4LoP6IXqlerTRYpKw+p9RRjEDn0x9WODjdJCwFJqHCMN
hDM2pIVwu80o+Nf+W6a5Ci7FmqqpzKeN5nX12XLuCmnhS2Pu6RXHVWvLntMagqB+qt+i3DFj
+tEeMyTKVJQIVSr4GbJfXvEBvv1Lgntixxf1txDGAVL2rVhWpY-4s-8pYqBjZrQ5VG4cQEb-
Gh3TzAULmvNluUmfc5KE4e8FTHiaUG3IsZq1rKUpyaqqUggWvUoRJwHSACyxLE8Eo51EP9E4
Ypbt8dteTVj1nD7t+hm3LJLEeatVI3LJAbcPdQiIj2JAPX0lvtDitqG4yGpDQ008RRQ99wpk
XbyJn14PQYUsbuP+dZDRiK0rgyF9eRN6TdH+87t952QKa7MZsDG5t7M6cCOIVr30XN20dglA
99azvCHTAgIULSYPGPcTbScvrUZaTmm1i1HikcSQ6E4eD8RRH5n7DAoYZjWLQ82MxWwFWb4G
v8tWd8237bMjCsW9kPLA2kEUMJB8ceHJuD+IxjihzhgrPxcRq5zpNbTzvrjRXELVFpxeqHO+
D-zFAMS9ybHWBky6lIUTbuqeSc50r2Y-hWVfsM8BASUm0sxkmh1s5uJQaEjPWYzXoBCMVsUD
te1GkjWqHFluZGWdlMWzJfrleZEmVJ4Xb0ScfuPZA8PECxo9XpDydraCaraC8nlfA7OY+rB-
ssuZRWVYSP6xBOLILKPYTGMNT41lfD2Yjhxe7QZexagEgikUKgW8X7TMNe+vzIYVlow7CGs9
uNDEKObPov4LIVEWw-SipX-XpDqUnz72tjC3nHz+vda6qGHK1S+J-baG9mRQYI8FxamFuVGE
Ipi7KMMG2GMtiQ7YlC6Cg+YZczqzjG6Ark6GgNAG-Q+gguOjHjQY199a67Mf-4LM7Ga7FgsK
9A4g3i4TiPukcYG29GXGhmYl1NdM12nuk-BViojAKdXS8C5SQKG0DHAnmN6mF86B2ccGWnhA
NfViMzQ8QmbEpstXucnd6tdBm5GvG3z5nZhb2AzVf6rmz1LJiJ+aO6Io6whpo7MgoOYuUlWf
FseYy9xnn8tO5-FJMuWdgOh6JbbKBRypZZVB7e2d21WJ81YdZbOrdhNbxxfY9uk1YkuQRP10
H4KFRNgj5c8DCyt87fVuA2prqzXVaSyHmrqTNiBuNDdJqo84ikEI76k7XN4kQlMgKH8HwWdu
wEHv2bgdghgrBoq2vdT8o2GaEB1EZb9dydZydacNQoqEY94MTWVgLGExolZc20EKZMUJ5wO0
8-z0smV4yq4rE0t1rmFhSRJnWntnUytFP9hbo4jdV1cNlwXjof4QMKwSyzb105d4JUWZP1vp
LbWnV5IEFrmlgio+nMGxvihTMMtlFF4RlhEdlSH6KONjdjKZ4wInwNW8SlBqWBTjvih-QwkX
3aVyTDs7MWen42+elql1mMe07P34cIUnIuaCFtbkDtcjMNvvfOgG7y4r9boN1Y9BqKeUnIDh
5idPl76krnnDR8OgT2p34sNneMiioDixS7HxAxEr8WHyFTBpvVJkCGXERjfyvCnRmtL8zRQi
H5t0HuTIGxfcrTKsirjiDcByZJNUIoAXGhpA6RGhaP0SoTXL7mJFbLH0fQdgJ11QW-D+P7WC
WejU4QBye9HPp9QI36hURr+aZcdnfAk1FkcXEyaXAAA+SKIl0p+2y4gOitNijdI7ejRAJvMI
0qyAx6h89Qm5A+eBq7R-FDKQeQkIRRGIIRQRhC0QOVa14Lw+aWpGJ0G3xePOgz5fMPrqS2y6
80mB9xPHO-2PlesOi3S3QxPZyjzcy-xEGkA23+++++U+qdjI6ZD0p6qR+k++1Us+++o+++-2
NKpjJKtdR16iQ43njJN9PlAl29tLubzkUIC0mY7-L3e8J764JKeVY0+C00FbRteOvhcfqxg5
WDzCX9oDPv9B9Y8EGyltT1CS4LzSEUf9dd0dHvVsTfWvgvgXd+JxmKCUHK5+vCskxZb6FBqO
DLMClj+Js4dyPntNYS9efSPtZMVlBJ5GOYKmaR6NzYo3HxL8v-54F4IHeoYthoatmatbrBW3
m61K3tAffiRK+wzQ3dR0fiN8KsFCiQ3YL6fqDUR0L30ITLP2MZ8Cr5NA0gOKJdsdbVmklNj0
KWIDjFUG3kn37sakXT1IEhMK6g-AO4DL2J-ycS34eA7oeBv-LNT54Rw2KaUSLvzVSVwJpPfl
k46huS1fLixnY9uctBTg8Z+w50aOiUOEeH9EYRktu-JolI9RVo92ppquAvu2Z08tFGbAhMcV
8HFItNyYu1uOUol+Ivf9vl1PwMMpaQt20Vg8OiU2lw30DsWndGCialum4uvNQKm3YWVoBbur
0J7pTK1WkH+Axu+N4KtBcnDEidscj2NmBO-YkNkBHwXJPvVtDJr1LSeVqy8GOr41My4Lme6Q
2fQdZiVIfwmJ3mC2MkuQ-BcurXUcyQCnLdObY64ob+O171wTTKGDcybgz7RnMtXEgRPwbfYT
CUToJ7sWs8zGd-4I7VL88Nvd1YpCYKpLc3oCHF4akiEdjoTd2ZN0YigZdFeJJ-JNb03qQ3H1
FEhp1T790zofiZTb1cP2bHY8fZkRsW8igoLcFP0Bz0IwL9Dm83dZV1E8e0YWkHiSUKxKCojl
+oMVm93linpaRG5XZaeChikdSz3mv640SYMn1HsVLlZ9kvz2sMwmThQenIEJoXvNPqIWTDaD
q1AbPidR3OmnO5qgJZJGL6Mw5NrQEJlMMDM8GBgYZc8bTATOoRlmDoYV5JMeZRCiT9tQyuZ3
HbaGwhl+Id9xUlrTneLp2BFXvYOU4T3a-9N5y5A4fYArZGZvyq0YLddiA-xeSJTHiy9owbgE
0jjSXjOODLBRNkb2ctNez2R7P5omhWLkOiAOy5m2z8hwhXt8qqdTNlA5Zr7Ep+4DKl-sAr91
1vYmUaOjXBoFz-7tW0ncYnLb4YP2iThvXDuS5v1mJcl1xatWTkFHd5EvXuIF7Q+0yyR-jYJH
PbY7tHTXba9rDh3Bv1IWMK5rDQXbINZGqT+qjxETmB5WMMMND0LPjlHef7pN1pHzJwGE6hEc
zv26zFwnEn8jITtFtjUTvSvw-Z-9+kEI++++0+-FbBEWKsOHqY+1++-g0+++1E+++2FZPKxJ
PaZoAWtYNar3JQhi2n2IRKOOSGGBKVN6RCQh90ceReV06e4XJeFBu2k3G2XUNBn2uclRP+RO
p-xUmN632YiKT+30z+nw+4ikDHCSV3PhfaElifZyb5jCTTVD0mHFM5xr+xlRTF2+Y+mXipsG
ANtjBApreMwDdTgPi+YvRXy-tZCGmebvcy3hMn8NGjRSkyyVMoYMxKtrCIN5+W6cd97mG8Wq
07oc5oqVM3k888QsLssMZSix8S60GrzZoJPow80TjClhDxmDht7KgQcmlbpzb5InB1te4py-
uTkCnPwxZ4Cjglj1432-Mwn7ML2oZeQNPbi5cgim3DU1qgiMk5uc0FYnI0sJcQFymzWArFaG
2tm76SMvR1lpLfIGT079l+vkYXsOsQknro6JttMFtLgZmdB838RXBPbzbAoUmUG1MoHVH41B
5oei8A2FsZ+ma9ArqgjNP16per4V4E-yodp7mOUzYfHDI1e5uekKc+udABQgNeXrkcVYC2XE
OA-Hn7p0-H6ywdT9mwkz+7f7JYeYXpCt6r2yXn+gOPqrh4tSGxt+OsUsdZ8vUa+TcrF+gxCk
th7ModblZbH+hIW-sVIF9iEwVtBGdMDn8fLDBXQVVCN6TPRXRSdIxtJ0JHVhtFxmz6OkaGWU
Heu0KhN+pNYOmvJMerBrzUCbQvybu-Nxy+hQVFLcnEfiEMqnh7-vjLs-FVyJmfbPXOgkKben
lbVkJeAo3mgAKS507B5ZrYIwf6mmTpNBzrmiyiSX9PGpxc+HJE76kzb9YawnHhudSY-N455w
ScPdyBFd-2AaWBvW+0z4qFNB5F+c6tO6GqLOq9kkIO5g6bsYT2zaLGOblaA8Hbb25eBa82kF
bK-zlQNNC-OHrqDt83OXP5s4z+8LN8EuIATX9qGyKXzLYEb7QN4HXq0yuRojs5yqd8IFZ6qc
***** END OF BLOCK 5 *****



*XX3402-050610-200797--72--85-47940------MWSORT.ZIP--6-OF-12
splgF1BZWx0TBFPapSDn+XK9aKmj1FRuo0nyIv0ukbMlbq0P-zRfwI9xj0EFcHpGMvIgpcrt
Cmz+Sn9H-KDlWWut5AwSiRPrvi7QhFS6qgV8cioYTlidZhKNPCdDySunUiIrc9QAXX3xF314
7irOrD1IEmAlxpNo9SV5FtnRKNTJkDfE8Bx6xTg9I2g1--E++++6+8uCCm7KIYPL7kE++C+D
+++A++++F4JhPpJiOLEiQ43njJRPPxgq35srsDz+Vk4J-pScytWg+p6v5U6YOJSvuACk-pcu
hfZ8d2-GQM7VzrrbY9dEhaQd41Mxq1kwxsgyIeIIZWoUJpxlQHoSXIR0Kh-PbU+FdE2n5X5q
HQVI5QmIDM+lT+SsKfqMfpNYiAcDelihyQiIzO7tgFQ7vgqJh3cFRuZoXbw9kHCpApCmBZTt
r4dWfalOfT91YViv3XaUQgMBCbPVq7Q0G4RBRaPg+oi64HZmEUn4BZPS8ttSgTL5oZcZfzoq
dAsQPhya9fRewv5ABu-DhiwgtBpBh9gIqhVXkvXzKQCHI8Itkre2trAOxznIo3fntDh5faT6
eBSh-ZNdgp9uFChH+R7LYzFOeXO8CFCX9KVUAZA4nUHr+5c5trkVvxRG7BzDwSvt-X9mt-PJ
Ne3J+aadcSv8D2DpO+ImRHLzhDY12XgtYGPFdQXUV23xbajU3jeBC3Z8wJXoaXplnKsG8tH2
HGTXeJAXRRQ5-VsAkr+Bad5VoXEu+uKPWNfjiRkB83YkNwA1QjIP9htApr0JNiUie-FODC3M
i4KtEHZOcO011SkrYEsofWfkwD0K3lbY60qbxhDCbnxwMHz4WyL1LmrSf+YB189Br8BBtRR5
uVydqFKvEv1QETrGyaT-9ITKmacVRlpCceGliYmgoemOOR5OM8NKacFORIOVgUwjvfClUNqE
N2feekxAC8gI5F62fY4h4BPOMPVnWEKfuGeGafn1DXlrwVuDqgMhV0YmdxBsliQUv9u8C8fh
l6vwfGM3aTpxkZ93EYrrP8ZpQMDPgQJrVp2u2f268l77rOZLeo+y4b58ilPnWRAjiz-oQzAX
3+QsFKLPMWr6kvO39bDQSx4dJtUTXdPMGR8BhhAEpqBmwQVnO19HMA-4qsMKZBCvaXfgINt7
NFac9IeR8GGCGdd7x4D0OcahosdcpBywaH0vVo1bd-RByqvGB1cOkWYnYqsXV2kW2KvtibRL
0K479o2huVhc0Qcq04JlndxRkxzCXeNFy4Zg0x2CM1rPNtjMRnHJSKBpkePQDYBGKeW9p-FX
bc2zhxrF4uwgpys82NtdBIgJF3JL2nSQ49tbraOwA7-K7rORk2bkZkz2daLB0orqqp0RMezt
ptyVvOUojdMO9bfeDKW1wLh3lwztuHqV+pTMx8urbxYvpr8KEV7pK7BL-L5lo9wIk2z-e8ZG
qfQn5kyxLzwWbcjLWYipPu77T1H1jEusbcGMQy8tlMF04I4nJzYysrlPGXSRx9JFQ+oFkRJg
miXjzFLvfBm5niEwBbw-IqPoOht66mc1OylT-LfSpWGaEqL8UfrrTazGIzfS8pQPmF4ag5+K
j73jIFJUpTsip1HTET5ubw3awAlQjjYpIHil5ZDxhw6VFKWgz6x3u9yQ1cawgT6TFMvzwLXo
Bp-9+kEI++++0++neREWlQqJ3Ys1+++L0E++1++++2FZPKxJPaZo9aFaPQpKmqvHE-GRq6YT
SOXd+cbij4NFBK83J3JeoZUdtBLO3P00GH77fBeSAduo0SdDgCk0WGJ9jU+VTUNyc4iMVlxl
KvKvEeFMsngnxxkntxsvzZA4fXosvXL+HZor+L05xcvaqdU2XN7s3fhcGhJfc9fsHDoAGeyx
0NqfDkhO-ranCJKT3zEKD8AS1fLB+lFU0oyhsA9N7kGif8eBEvfRaYAG6Odj59HhzNCiyuvJ
qHxqqatNna6T2poTyooTXYwfkWNx8xSaSCj1+4apbaAtA6kg-l3j8fQuRCKXWXOBahWT+5oE
hbkQ6RrYUMiVkIk2EMfogf07QKrc9N2T1F2t1ARntLrNFIgO6xO+tbPV0DaOS2fqmZB-zYR0
zaJ0LeaZr3ywlEg9yV4qlX0o3V4mu7nx0OBYXG0l89M0TAuh-0xaQn29yFZh+u0vnEKZCBF5
BClWC3Y1JScGIz2Gm8oIoiFf9RjnYS50oM-A235Y6LXXIvoOClBj+7HQxgGX7dfEzW6M6P8C
AMkl4Ub4YoTF1NG5Y80EQdBV50As4MHymgn636dQ4IqH2GQQRAPVY87+AVWiAp0D0jwN-IJG
8D8+Au2BdcrhYMWiev0AJHWtfLHZQbTLgWml7TChdZfL2bylq+ZCVRa5-7pvS-37eCJ1I3IC
ZCn7g6cdJbrBtkosbfxxFZSqXBzU6Gm19qNkSlZC8NSzTDsCX0uAHovh3-v08DD354DjAYDF
wZI0osAnLNRLP-AGAlb29O+iKg0Ld+JQdMaqJFYEXuI+t5-uZN6C7ht5ZUzEBqq0DWlEC3sd
-KC66swjIM1a69wRHVFUg6316O3gaAOaams9dET7OOFfB4VWCVQKYL1A2jJl8DfO56Mnd4yY
QId1LjkK1YMC7ihtlbGtFt3YElODYJAyaQxp3JuFfVQUeQYJK4xQuZTk9ogmdK54VQXXn-SW
i0VYu4w8iNvvujM-ZSGpYfchtqdEHBt6K7tVDIFa8BJ-zGMjopzr044aKn8gGcepiSvn1fmX
-IyM32xKmTpsuNN5jP9jpeeO6td43VChiA43nIeK8pbWXzUH-IiKrk3TAXV1sM25THmfNAC4
lWt9WcWqkLC-LtnFtPBhaXGgHsLsaaSzjp-9+kEI++++0+19LREWjBFCB6s+++16++++2+++
+2FZPKxEQaxeNKBoAWtYQ56f8AdD9ofAJL-7nQoD8AfDGYoiAP9atS9Z8WpC9SPZIZ-kmmz8
9RM-gI-8EjAmGskIAjAIpC2wjM92MbK3Od+ukpekpaeJ6+IhjG1Ls3cE9mYpDHADdBylc0+b
Anal71AzHwwHe1AnAGSn8hIOLQet81Kl7-JYb2M6q3+Rg-gABH3I-dLa+QJGwp9oS9Y+I2g1
--E++++6+5CXp07QTmEEokc++8EW+++F++++PLREIrFmOKtbIqxmR0tkMLChKapjqnUGzZuU
zq5EDS1gXSCnYyuphNg0QP9N1N0rOx6KVm+3O6aqiN335GIZxSLqjxwAroF7RdBqOmkq2XaQ
4EtbbdaVyf0pzQByKwyTkTzUE0snaT8o4+5+pQJZcIEujtGeA9C8gs95B+TktdISqmy9VJFa
02uN8YE8bpUGwrFOefZZaeqIa0w86VaySTCe-ml7E+zZc5XCpFqDytfqYCSF2ZYVN1e06tML
UDmKT0bJ0b9IUmiMGEJ4gRmgyQVJfiYpzzuC5fkgI3Kf3VkdnXwllL5aFtfgHyHr+6QWXl6a
ZZmBw-rBhV+ts5yNYbQWtX2kSio-zt9VLjBY-TQ0PJMKkC0S8QLGMUJm-WlRkOp6hG2+zWp9
85AC+gY8KAZGUPlDoKVtp2StntyJ8IshvsAn4hDkkxzSPyjttwx2WiOOgMVfwdnbQ9b8DlEW
EKIycG-tXky5UWJmbiiplGfHh9WdwCk-htTbE9g3CklvwDa8aSQlXPgLb3+wYWe4EpOkYHoc
s4Yw1dPjsutLaYTkPjXI0QUweyh-jnys6FBRV-611QZhwLVlkOlA6r6Su-kLT1bg+TrN4PaJ
rF2QcpLaL9Jss48xnwvJyTED5VJR6gWIi2AzoWQ0FoWa3Sj-3Jxaxj5mbdb5IKprMvjaE7MI
HO3IUBY-mpUYWhKcALuCEG5GoQL-Ufal6wBoJBgwOGMX5dSsuJyzNAmOBlmyt6KHoXbXxoq7
LGTG4SkrLZn7KttqXhCMTz2ORoQPl7tmBSSR0tbjxk1zDx5zDw46rTRDYl4Qm5GCbAO+hfCb
B3drR0ppQ5nOyOBQNfbs9lxI-bmIoEWaIWOQdKBnU99+kyFlSvTY4LZfhtigT9ZykFWoVpIC
NeGKooF2VYIYovlENJEUP2IOE0rjaDjlEreIen56CusIUYPH4jhlr13mb-zL5OTGItwVaelX
LCaWE4kqvYGEe9lDJ3higHV+uvINLv1chXLsfp72hqHxnVDDhy2zrvSIT6A6Dbr1ockfVBZa
30-MgPU8FvVLceW3Hch-9NnBQVDXHIfh9RRpPvblTa7KCWygtCfLATf4X7J7WqQ61pNpAqEN
q9TaAioH9JIOWaWWmbjnVMYNUxmMH7NNkdRM4H-mG7pduj0dYovcvC3grrjyZ8C0l3WY0ot8
lvOgk1Yb8z1aY6TnmniaWA3lW8eS9JI5luAx42+VnKb-xV-WGLCSe29JjEfJfsxjfC2kcqQm
ttqXA8NR0fC6XV9gerAdBz8SMrIXcpCyv+ENMk+zkmL4tTagsu0W4qkt+6DObVom-1igkjDM
av+WSwG4DZZsRa4Sw7i-9FUCRZtq5qTsV1HXFMKq0aWzMfJ8cOxOnyBYHPKjUOPLuHrDAR0+
5828Mn3nsri-0gK0dq4qlGrILQGyTCvfqaRDEs0RQ1taqBtcSI4aCIuXXd5zy9OSY9fKvOtm
QpdqwuGHTKf4eous6OImkWD0P5M733zj1XeUjwAL5exiUXqgUENbgvd7UyByT6jTZNYhpiap
7nmh3t7uKEzSZubXF8BA2syeqjbZsAojibmq7-JKqbmm-puZQFAGOecNBmRtiDgUpxkjFA8V
UlCTsFrwBCWq+JTnkKJ6AnMXvIIMKDPx9EsARsaB1UoQQubQKo8nUar1SCm2e-DeBXj4-Xpb
6PT6AH5HpquMrDGbUNoXp11nrHK86i2EBIKMfhvLu4ZQkHb2+olMXWWBHgYUZSYqhYUZxelr
EE23AmKL-13kyKbzhypx3GpkLjS05PXuG4JjESbu+vJxolJA38PhHm77-ADucIjdRsDTTJCB
Vjs47rl4LYLhCJekb9d4dtmO4LnEYmBLrBiHkNs6Grxl7v3+id0uyzHbUi2BnWK5zTviXbN6
qmcS0NIXLqcN64UNS0BFKIocx6PCzuDPOnRyoxRwk0TWtfHVjySe+gg2I6gA0l1n15frF9KK
yRVFOECg6mAVbieEFlorpTKXRLbU12jQuCysBiA3uMRUHViuXikRnKP9Y5MVLmUMrUF9ac8R
OpRyIM5hhRLelVtd3xtW1KDxrAtplozbdLKea9onn8m-XA6pPgR5rWtjxmd1I+sCmKcMIzr6
3yiqQRgNBobP78q3FjSjfnEoh7FYhqUrKcpyaupEZNraVssf2ayMRxsi+IZcC3Vjh1Iagzcp
DBLwBcONZTA6iEivde9BjMJ-pRmKqPTNR7qHhsX--VDv5bUzdBUD34K8zIKW0nVsMFdDz8hY
WMX86SIwnc53gO0mUGLqiV5NvqDXbQkZZhW97PIHq2oVimIGe1ZVATNR0L7+m0n2YjhfDTuZ
I+nmHBywoIpUf0wpdtU-ABbWo8EDjtQA4J10CyoXw8Lnj70Mfpv+VK7MjYGclb4ubGL6EmhA
sZvoQ0o4pv7AYM0InEZ2OJTv-uSkCykArvlyrSr-vgjLqvizvDErtsETTrbX0VJoTaG+A0vO
hPOTr0AVyzc2PL9J+lHdHUyktM-K9tWMUAuqw+0b1Cpz6aJaPWMPPcoZz3cc6XY6EvK-mIqL
7+kOUR682rzfRyqroU+9gsouJ+UA9FcCkkcRp9rk7CRzKSNYjQl7EqO9lf7oN0tir94o1cIg
HvOb6cgesM6QoC1-vmmNfHq7PvROHPCKzRMcKLQEfKF1loigBB0Rze8GYwSIbBGJx1VoJWju
RDHZ36R6z74f3QkM3I1cgnmJtLnVjbWkCmMGBYpo5LW3QNuKmmZLh836SvP6BEeIJ3oWo-+K
6Qv71D467HpUIw8XrLywd-Ky1WFalnICU20nEUm2Cp64FLAEmkl74FN8Ge8FWkJ92RUWz1DL
po02FJW76by9WbZEmq7UohSA08hS2hN-V0DAjSIc-2hbNj0G209J-UZJGQEhsVaCqxWxEXU3
***** END OF BLOCK 6 *****



*XX3402-050610-200797--72--85-44146------MWSORT.ZIP--7-OF-12
ickzcU8NDVlNH8NfAoFQCCyQEH85gmvewzRQku3AoEdtENPfcGpNeh4uU+EHG6ugy5x8-3Wh
1eeeJuXMq3KYKJbonISQ7GOIOKU87AsZOYsPmly1pqwciQZbK+yaDHXfMO87NMKxurjWsDi1
inQ6ia7HSrSB9tvtQfZSzaYlfZGaLvAud-gA6Ud+Msd119PCUW59NZcTFIySMbZmt0zUxBo7
9TR1RKdWImrEp7NnvLOJTWNr4LBBYN4la5ucf3o-bmYEB+YmWqfAeawrEOGDsK2zEThVoI-i
ElzVP7PJvMgyRvDQ9v3JbpbSUVEeO7kUDoj5QcMZSi9P28Dc4JYVp59xeEz08kzAVKJGWAlK
-RES1jejzUZnX0q8uXmVUWYVNms8TKihfn+cdYZ49CtAuC4uMLxLxtkH5f3UtoTbvm4VJ6h-
d2d25+6g0dXI4cKWnHGcCWNZmjzQR-LnEvvgu6ha24fCgd2q2JJyiCQebcHtB5Sa2PDlqEzh
49Oc9g900D+8IVMcQAxFdTDDKetngI18LfJgOyXDXslB5e78zpo5EJ1cFdL8GVj-qrvhxcuv
E83TcmHMJBW6KZJH8LJXaeobx+1hdYYoattkeh2aJE6rfUZcBXF8pSLOX43RJ7hRJvxI58i+
RrEabednP9E4VkeXkzlf+hALY3xKPE33UPypgKDttYiO66jDR6P9AE2bm9z8qA7wuO5kG5ku
l8JSAeKP8dyORCeeV+uQIotXACDrE4p4XVj7cPgt-rrHFn9j1F23dz55BdlKwK3gesY5HHdb
MOvz8QDz+J-9+kEI++++0+1seREW6SDWh1I2++0d1k++1E+++2FZPKxJPaZoAmtkMLCxJphj
qnMITUyEzo0USv+5JvCHPgCQiY1el2I+dwhe3ro6Ac0KHaki2WZEJ-8ju5zT6GZFZ8r68cMh
9mPDtHgL5btIQgsIiM-2TAP3uRbloT2FskfYDEp-Pz6AgiAXEfsk5cabP20i6Qjc4b0pq4OT
3MhlxI5GRAB0L2o3Jp7cqIn6-5wi46r3CVhcX8Z6dYdetI73lGdtah3A9JY0SbonrJ0tI-7c
Iaq3J+UQoklHAEaePEcOPuZXXAW2V3fNAxiyJV0mIbkiO1EamzStIc8TKH327VG89mCa8i4J
UeEiF6+NYtbOFI1tXMF57j8gETIFbdgwtbETO0ZdyD0SmV2embLZUOpOuQ7rjLtDURiKOfxe
Js7WQJdFRRK1X2I41QZRUpl1ImnIzN4nw837BuQfW5IYgmW2eFEVF9a2gjrH4Bpv0y+FG7ri
uWw6JLzDKdjCK+lv0bqUIlk4-MR-X8oiQRToX1lGGQt1lEF5cP4lirqEwhEv7isBErQDDGDR
fTLcR9Fq2sKrVewvhAmPgys7aTtpBrTHpRr31Jq9GmfN6su3LEe3QcXA7ZyVYphZ4mh40AAQ
C+ZuOrVXLD05tPkYXG2-feUS10rtygAbwaBkAPjyNhk67bEi7RoGwsTCXdm84XniwUqAc1+d
AOukcaQoiI8aLMAo4JEhi4-N4hAhGZSkNZmvrih2Us8c+cIHFAMH-lQglEDkqlfu5PeLJLgX
MWcCj+jbEhm29Zi2LbfPk3t-IwDLadmaB4FeWzOXox5kptCnPnh6Bd6IWMvKwwUfo68DB+3v
bDJ8qBzEwo5CAvAP20Jn5hNI0vEZDt5HbzgKm1N8uNikkdgE7DGtpeadm9ZuDOc3NTMo7aFc
l3Lvmzspxj+ElNKBNTQyOESLnl1a0cXOUBNKWQJUyRxES9-Ep+uKnsqZGeFuJvlZNVfoWFbZ
NInH1880yJwQU5NWRHDVNhtAF1bjpHmosrwz4Pj+JJxa2ZcX5KHg0jCZ+qwuweMs-ubS0sKb
LczqXUnBaNA6kZtBpTyi73dTXvM2ritR+dgDszwebxPreOrr9djEit8RcbNstvn+yt2fRYV3
ljHg3P2PUhwXsKU9wU5I5DVOPLf3Nu4t1jplFS5Zqw6sXEipbsaJHsVlBk4TBbWjfTlDwjMR
SHIu7N2k-q82xW+yENP5mXWWX9lq+6odAUsv0G7FAfuiwXAAWuLsfkwVp6X5VCdCrEu1sArk
hpziW9UbirIszwZiHkceJr6y3SaqNm25Bhy-wyhvwKt9sFqWjFfKuvIaLe3SeTXNYZ67DToQ
XUN2ztmsWfr0eXZkgCQwMsLv2ixGfymOUScDW9wzAOx8qzUTz5ueAhUVRi9TFkjmdJQYJZn-
Chyvzpu0tQiArzbShbz4iOmBqE4cktxsLNfUIDv57VnyoimGiIDtXn95ry1su-xEGkA23+++
++U+9L9I6V8jxKF1+k++QEU+++o+++-2NKpjJKtdR1AiN4NhlJLBPVAl25Nqazp74fIQYC1a
AsR0lEadehG2fZeFBYin01W-YrIHevhqgFpcIJy+6wQSY1Vmt+YEsaLU-HW1vRrp7fFePmJG
fBallxzABnzyok77B1XMKkQDJZ2+E-751vkYMXlTPtdpeMwDdTgPi+YvRXy-tbCGmebvcy5h
M18NGjRVkyyVMoYMxStrCIN5+W6cd77mG0XA0AJ8EpAc47Q0nUGV2lXrdcW9tMVFiKN29DqJ
lxjFpfByweergrIkr2tOlGv94DTxQRPBoDWcPLE3gjAvB3zv8ARSNqw6VsU8CAGQ5-OaEraO
sPNr89cgGs2zc9qA0Sm5CWkX-YeZz7HMPlaRYHglCQ4NW15TdSCdwveJs-BN6bO+ZzHF04SS
KEhib1i4aiwJBL33XRCln1lumKMENM9-AO88+knZJDqt0UaC26SGkNmxpJfCNdCdqHIQfE5U
7xqNZ6nu6obv18JncAteUSaE0j8iVEnpKFWF1+Q74UpsWfZHY214FztmSNbt+e0NP8R2yXWJ
il9bwkVl4RI54xLh4oYPOAK6Mmep8UUCA2c5B1gBupUOGnclrd7qi0MdI533V+gt5wB7mR8n
WmmpnnMq66H4d9vPgHlpejh8cWeQhh9559wZP0M8e7Dfc7MpI4JHMvYKOrLinbzURCvrJPV3
Azs0pq23yf00qullZVNmfzQjkSWXYXZrdr2RFYgTpVWPNnJ8Qv50Y0IiH-7RvJr2koccqqTJ
hAzbebrCPO5RPEwsIGK+B7mz9DYCsyGxeUSIVF55PqOMXYyRFV+nETEF-rV1b4rHp+4-2cMG
QOZ2utgL7geJDQGDVCz7jAjYp4VAkGaBq4TIn6EdcVDgfpUz0wJWwbgg5krJF7gT+Pz+3Fad
14dzz6LAJzgLCX6VCGtmQUvaaxvx+jtbGxckUf6FhNy9XKW4PC5uWwP0j5dmYO-aAN9hhS30
1tfBTkdKJxUStVBgwy-y9NudbpQY6fEaBJP9MhqOjzAGj8QnLH+KfyWGez4gmMoyRtTbefoE
eDKg19GRtCwWpP6uYoqxZ6wz8u9w-jGFkH4aXkb8q8FRWyiSSaUYthu8fULxu6WnSqim4ZUT
4yIHeLtz+J-9+kEI++++0+1seREWWqQSLMs+++16++++2++++2FZPKxEQaxeNKBoAmtYQ56f
8AdD9ofAJL-7nQoD8AfDGYoiAPPatS9Z8WpC9SPZIZ-kmmz89RM-gI-8EjAmGskJAjAIpC2w
jM92MbK3Od+ukpekpaeJ6+IhjG1Ls3cE9mYpDHADdBylc0+bAnal71AzHwwHe1AnAGSn8hIO
LQet81Kl7-JYb2M6q3+Rg-gABH3I-dLa+QJGwp9oS9Y+I2g1--E++++6+BCcp08MoNe5F+g+
+0oZ+++A++++PLRHEL7mMLYiQ43nfJdhPxgs2juykDu5kS8+gvSC9otuqnPS32WHdVRQsiOO
hA2Vm+4oFBhg7Qd9IIaxETvtTPUNjcaGvHWxJVxWalkC5ktb5gtEiRzu+Qz1nnzRkyJ3cEuI
MUjs-6Dy1jkTXx3ndMHKLA7s+KRAOG5VWaIdZyB8HK5kuhK9zhDob4QgsGbc+jGAkrYpnYE0
FoLCVBmgkHt4nuXEc5adiMMvcKRkl9DtH+mSecAScyR2zvK2iGdiFMekK+aWv-aBFOK-kFp1
qoaxU460H0vUWt-dSkuXtxx3-JL7ES+c1MiWIZ1QGJ0WH9tdLOEblxoWLImaY6dG8n4ih32x
INlbWko8GQxavxXwKDyNWF7GbVQGQH0oiBYrYQwnbbCdaFO3B2+7A-Y7mY7dBgssd+j7QhlR
csQN5ul86OR4UtvVIa10Ghd2AsNu1f7dUMsqms5RAd4FabtXLT-KTWsKO+fQBH94hymrTruU
TLvyeN8s9TbRVMal6PLQzyK1vF7GQnJ-RnRm7NfiMZ3yp0711vh0DmfiGXB+9yMc+b-yh7+q
JDTVDtTylt0u9eAiMwbfvLtzysMATZuMSOkM-fgqQcR3DaS8czWYYcbNdAu7tjaU-zGlgyT5
RTTU-1ybFcC-XpeegNogtFAV-JQOrN11CwLZboU-L2VOWlAecQ9R5yAiWXnLI6kVNGK-0Jea
TD9T9BAMKRWRQUJG71DR7tYXz5L4pNEHw5frel71I85nJmeNoRncKzzAK6YT4OT-C0nXtNWd
VxdwBSlxG2WsQzZyz7YbiYixQmJioLrd8w1l4Tiu-uS3bC9OVvOvo0X8IzD1g76HDSIHLQg0
rAAKKYlckH9ldqKmvHvtZ75y68OnPl0jgakDrVF3ldYQqfP2F3eJu29-cS86iMBcDv4gsY3j
pwaaD6USoRRWAMHWZWi3NCN2Q456hlKu+e5co4fSmfE5-WVyKx7N1lXlfxMsL8Na7PK35umj
KBArXlZXSfj+ib5nXV+k6xhnFXEzxict5PlXfvA5ZnmTiuwLRqni-dkr+UQ55-OJp94LIyjY
YApN6jFWfxZSfzu0OmzH4T4vhjmmiRtybGAD9bgHp05sXijCWIntpk0bixQ6s3XTSRIK5dfM
fIBrq38DEHziT8vmSMaihVoBEtgtEhVPtUW2A4tsM+r-V4PbwR51RgEwkGY1scAovHHLpBuc
4gkVEZFh-ORsU8kr6Fa2+3wxNErlk5xJ6jZ0MhwuA71NYkTCYJsLo5FGk9VDbST05J6WRnzO
kwVqtLLHGqu0DOmORxnfE6wO2eSn8ZjGtAAe0W05kjQgEKt3V-IDUSLaXA8cxdFmNYC1arX-
Yv8FHZ-9PR3++Dr+FqAy3R8W2H9d4Cvk3VIHg+rkqV373x+HunMYomtZ6B8mvnsQgunY1NuX
WGn3fM8lYIR7VEo6GsAFL5iOv6APvWb8bVfvEJaxZVXqAafUxASpL8eeiEk0OdQFVKGx1VyQ
GlORQRet346-fxCpKPLlIJLfTTnEOVg12DZqkkuB3ZkOBDP65hvItWRcs9CHKrXleTHEAc7f
XskEUBIwgwcIraI1+xKu5WSncDw19n5yn8feaAOhRirIv2D6P5VofcFMj9P0BuG3dXGx7lE9
FaIr+Vevg2QOJ+NEwKZLnzwA-hgvnnRdSw774SM7iV3s71ioVa3NJWFbDCx2drmBtZSsk5Dh
zOHXnPg7aBz7O5N1gxuzcUaXL48vymWOhbpLCA84MruJ7sGBBSBi5hTTDjFK80E6vjnMUg2a
EnodpOWhq+6PCO4Tt-vC26WMWwEKWCA3NfojTcCdiALG+Kj2X06xKm+RO5hE4S-ulgkAePUJ
dFgruCyOIi2BHtWfAOZyD5vz+P8Wa3BJf0dNqZ6GWqtd0uEGGgpgIKbi-kf75pMOwkQYHMM5
EOUdaywNjw2UdiJWpmpH7flhWXeewX3LnFG5D4zJNWcyFmenZ-TUYOaFl11EExCjNZtzz2Kn
vBT1bUpQhrKEy91+L+c7IFXGdS92SQpK49iposKog86BybMbJ4qaCYuilIojQdAOp2oLnv7h
kqipYWKhx7-Nad2VPcNBYPWf8FdBi5NA72C1OPuKP-pBYyXsgEwDVvFx8+ydBLN1btR1Yscg
qYR9EG3QXf+KEiSZfG1bzgJYfjWVWUdRa3A+j42Z5YHcieuBvXy8r6VTL-qwqnf+IVaJYCUb
fVMa5bd46sNPXZl4VPR-Fm2Y854oYN2lH3bV0pxEpFtadXgcb+VHDJGFqsGsl0+UzFps9n3q
***** END OF BLOCK 7 *****



*XX3402-050610-200797--72--85-37649------MWSORT.ZIP--8-OF-12
4Ins5R-BKMY98O5vg6O4btu3-oR680eh8zMW3vC4fID1ahI6PvTZOWs8daAU0vaZS38d2apJ
dzbfPMa9jTl2aUqJT8GI0YbdXQ7IxodYaK-clWugKTYrZ-3630MfR-ZZ9pmTa4yq-vzMH14y
iP0VocBnQJggZI6LaWJTMAzR4EruzRoRQqa27WUItjN0YNDESE9FdEJjtEOyugR6g2FWp3vv
xdiyoJDbPSpierwTkbbYoAII-y0nkNL8Eo03355J725eW4Asiesu47jnUHQgi6FwqCU72tYj
INwlR7BjH1a+qN8fBweNUY5ADCq7+Sta6iCfiRCVib3PqcLTYH5HkeFrfewvT9ciUuZKxhce
QkOmU-jOHcu1LLvTfkrFdimJd9q8hjpmVarFNN4ZUFPvsmChn-c8VzJKcqSx3RcAPsb44yNp
g2gY2VgCJVhhVQYQjdObqaRha9ZtBcXvg4g1LHuxue-e9wiiqmuueGZMl571uo1v8D5Mo7L2
MWlPi1DBr6rIVld6nj5IM4Ye80L1f0bbSO2KeDt+Faw0A0bldp0C4cW4VMEABG-ZOd5nw9c4
mrO3VxrQL9a1SKxF7YeAYTm3rACaBrrsFwJE+PqkCCgXwQZdeEjNEpHbWa3ea00A2vYpdvRI
-X-BxogDlq7ktNJo0Krdox01knDM5LE4fpuyvDNUxzb9fRqzvzHLbERDj2xnGGDtwrZF6XC9
tGcmRCt5RuTxsy+KZVEuXIsedfhavNrsYhJr60pU-Lr4o9ebZ3avGye4out9yBcM4jZTMmvH
qmJiOSS-Gx2FWf9fgBkKFmmh5Ndg2LK5qmDvc8Tu5rG7wdocqUhgksXuZr2oF0aFRBBsCj--
tHSpjOKoPyPictUj84bJt7mK8o7sfhf9vnBj+yUOEmwVPniRURt0Tc4t0PfcRoBzN2xOq3Tj
XUIT44rIm-lB7DhwCAerAHus98fdn73Nx-sH-GyFAScQD13FN+fRYZuTdYFNl4f6aAIQaMpZ
DK-XMfPRjnqb2G4T74Ib1Eq+Z9KUojeKkC1ItWIhjMf3Z2hVdKe8OuH6-1yatf8JK+rHqHf9
9uC2K2XnjXj-pBaaz8SVH80yiPhVNaGpohMNz0iXSpnER5peGUie1wcNeGCu9jh+9ruC8RL4
SgFHj8x1rbR4Y2pVp9JjRsZR0mcnGjAqiMQ4NR8EDqf1vOFeVTxF6JxvH4O2GZq-6ySJvhjL
ppH9X4Bvc5-NsA3-emgTNygbNyzYB8k5sluASbVadILwUX4ucJZptSGjvJNTQQIoFaaCXklz
oyfjSENCC5dxhZZu379uNd7eJZ-Tl0vbg6mi6Z+cMewlBX3sBceOb7dlgnJW0rCPHbM9W7l6
37F4NamhqV7fbuVpbwpDn-1AL6uHuDI7FCw96wsMkjp-VYP5d6Lw99dggZvSTz11kl0LRRfV
GyF20NKT8DGGkIQM3JYcUmnGoF9Aa5kJ1xTTAOzNNgxFyBbzYTzvgTGDDcE+QuOIwSE9JzED
6TF8TiQ3hPwMzDNw-oufx2tAGmzwXegQOMGyLglkSykzlVkK8Ty-zsHlDp-9+kE8++++++08
Vj6W4vUy5YYL++-73k++1++++4NdRaIhRq3t9bddQ3-9+kEI++++0++GayYWSdm9t+6A++0K
Zk++1++++4prIo3mQa3t9b-VQypRPKzPC-9yjg1yVw5WU9CvXexdivRRtvd+Bhrg-IXGLdDR
zJ1Y+3eWPJsZoYRFQLp-zjgBGPpEgakfxIjgJ27FqwAFNnUjnkkd+MYtIl-CfcuZ7BCXPvzt
xdivjrksiBRT43RI1cV5xMwscV3QHODT3EiW1jn7i0waYPZ-HQT6+j1yvNGPOS+BzDguzL4Y
VuuR6O6zDnvjRdzTU-X+Sq5YK9Mf6NLVCl5Va2W8v6CMSsc71eonFQD11iWD3vrojbMDnj-n
O4MkuiAgQRw8wya+QRFPXGXoFQlx6VbyF8Y2IeM60DSF2yQ81HAPO3Lo9RYw926pUU02-0tI
puW8slRI1eZK4Mu1cN-AXI9BGYb2e+F7WIzu+MI71i-wCC6376euxvb7QZLTqA5KxPjyTuWb
qbdo9BYhIMMFsDG0TCv-iS-1LCyF5FM8KOZjTgHxU5Y7unYRe7kLs+sCo2dAAF8kzp2TZ61b
LPVDi1yksSU-v4W65jkWF2+7Dv6oHz-6mRVHO8+HL9SW9RHq1l92B7irbT1uB4Bxevy8uF46
KmcZwqb0UUjne-yXyvIK9PqOLvbT+OAcTdiNAvzVYbuqle5QBmj79LljswCOrgO7Y5P6aBsi
A0QixsXVSwRd7zZuDF5Npt4Y4TpIl19vnavF7dZKmE7CIuYRi8PVCDZuBG5qOmzDfTG42klb
tQOydUtCm7VsH2pvFLdibmieIdvK7NqIyKQByijbASP5P9l-bdWzIRIusnvxb8bHvVLGqdrj
TJlaDX6NbGTon0oanPHRKaWZ--VugpUlSyBPx3Ph4xo2eV4XqSeDTPxJL21N8vZ07tUngXn-
CMbIT5hZ43BvwKAepFG8wK5+8+YOa0-GoSF5yHOxYiVXoI2raLNq4jFrAUQuwoW196a1aNbG
W5NWBx2W5NZFiFGAZXq9uIGa2w4tru8FXIdeEVJ9JnUCO2Wt6hf2ai70J7NxrQJUpOR1ldBw
om+2jHTkD2p++oM3WesEyDiI-32O7FeoBGoJI6+a8xnWIivkL9aZs8QbgK3fgOig9kdCPWwc
XSFogcHC-gY0TvMOMz5X3iWHtE1JzmKIOpZOW3NozX6mG5PIMxlf4MbhL6BKdc9FfeqfPQhJ
enqfJo2B9QWesSFjfYSOmHCeX8UC9-xQVbHCV4ObRIj4TIZ8EbSYN19mf8yGZMNgVUTtL6iV
7Njz+sokzonctHaB-YrcadmaY14U+yZN9buon1Ru3WrGX7td9tYdqsuWfcxHHPAdAuLQEdD9
zltS5zvoMhZgBMdI7WSP4lJrS6ygMIUE0Cy0VWqbkCPOD6Afv4zS1JedSRjZqtlWjCGqFSh7
+w-Fqe-nWVrJ+dzDOCAg6VZoJzxwQH+heR7JoNE3VvbjNj5wtH7KAO3K6OZ--r0sn4epCcLQ
d0JZbI-CVRlRulsQzl2MM3A+2onXI7RLY07KqDjfljtrDg1G4bB2tg1Y0rlbOn-y7an+8TJl
3hxbqUMYk3Z06ORsxn3rhU9MBaBVkyZ06sPl6E6+-1U1YO-MO5Q4C0QUQ2Y0oRXghPG400qS
N5o20gNvGDeZ0zyA0IuUxmcLLSkNy1-GUbREezSGc0wwJCCA5sk1bAAcfAJxpw3vgIA6MssA
KZanyR4fCXutU7S5fQCTLfxiRy1ZexQ59rxsMNfw8Zwwc+Kv7J9vEkTmSl3-1xUgMaK1Pz6a
iaiUzgW0waH2QCDIQYRpRKqPxPTmRfiGf3jjNA1CBiRmPx6hShJYSgodrFRM2Gs6yj-QW54m
5L6eWE5Rr1ttibsg9T8a+yIlglMnpcNzM0sPdAup9oVN9WYlkFlNRernVJI8L0tosT6QVSP8
b0hrBRbKVQh3uqiiS5pZqDkl0y0P6YuKclZiXiNBZbBazR5gVQVJBO0PgIrebphguE6Auy6J
J6lIf8huHJwM1YjWTyg-sSWnp88Khka84Q9g+hQAIbJkQOvM3IIr44KjfkSXb4XPVLX6pJZi
HwruRIN2WJeYa5LTDRjcRNy88pdn5zf1jALRTbysGDMXh+CdBgiP+SFggBSEajukuExboBQZ
f8IzL+UIayoD4smmJsBFtKVfygCboVwujzEXg2HVx03MSZ0xjjDDiKSQjf+WayD9vFlTfapT
bbDBWQzJQKaBPIiBZeImOpn0vdzvD2bb9ULwtK-TOwCQT4qqgsJfPLpOnhLUFS3ul5r+YrHi
Rj0WADs69JHVQP+JiMwhJ6rhExB03IUB70tgcKfiFvym3afNXhBVqyoKOXBsoPFEuTLJhJ-P
ksixOe4qUVTpKuWJSeVuPxFNYHjNEepw+BgQIvWYDRhqi6GaTQejdbrO3OlcXWWGuyZVFRAu
7RRHPtreD8fPJjCoPADJh2xByxGoHorvx3HOdtIT4gsJf8yhbyUoWD2k-qyjXRcr-yxq8vL8
KoxfP8JKCfhiRdTBvf9NLHOvmuOJKWNMLoofpPFGSyfUdzF+fx-VvTGHitKCiGfZuKghVkEt
FsKzjmlpptExGn7bAxJetHR+JfH6UVtYMTylJtvO2Xus4uqxVMQjTZZwvx3VMHDWgCk2BanS
HPg81ShoovO+MJzSy3Y613yuRRdzM3XIl1cgik2A4rTHnU914hqoRa0cQnWvswynautVDve4
ZQyW5fRprlRbPEwWxiSJZuNzq6zyMSLHn0QA2HjQFHn0Gr59uYI12CNuMU0laKRcKmfHHlsR
JbY-NARTx4WCj7cxFVp5BLiABID2zfk9pVlyBLiATMS65SsWBfH5K8KkBk-VfaODgJNvB5iA
X8I85Sdg7hO71mhpZ2phQes47leQq-dCn1adR7e9FrvVcPMttloCteAZExMDw7KPVrloJcTu
fbjsMuV5TxmoLxuP0yg965o1mPT-RkcSL6Xrmc3ngLsynewz+HTtA4R7hRlnvwqfVzBfsEfS
erD0xiUbOFghDCjqryPVww2566xxo93LzhgiSavaJRhJncvqr5jPFQxBDOhQvn50lf3fnrBk
IsyHJXeTSE7Sr4ciPiV2PuJnaqpbk5tuo2uKvGDobqQ5i6AHANv0-lcdzOTiHtb29pRlrz-0
pFxhfvqeeWuzc8P1tumiKiqgU3SeTIIxUP4s5fqfuaiJreJ8CoTj5DGAtWL3foRAfYrjGXme
p9mAHBKutuZSdPcSJOApuJuNVpKeZnBmXiMN44pSwufQfRGwZAKdtibbrOLU-t7ugMmE2muc
5B76GBJ3xXycbA8+F8eXMNFm2Ex52B7E67bQ2VOETY+pszK6+cz1DdJucNs-KlMlkGC66yc1
Ws-H6cAdW93W6EYuEDcWJj1mPuzo5Ty8aTTd8d3uJdU-lU4NFY1UJWi1cWakQ6mgV0iE+aqj
FcE1zSnVlt04Z8gCHg9Et92OInYEAclm+KUXf-xHw2VYB4z-CQ2JkmS8Eb-g9-VLi+mWPFRp
+4z5iIYspc9EWX-VuAA-bI+oohA3XBCc0qqQuZG82+UuznUM0gYIWXLAvpeL2+nVgcp8zHLG
BEE2FpB2GdijUkMZbD4VJXZ+ToMs3TpjH67A7rC5x8pl4Fz5eegnC66EcuXjqUCN6l3GgnfI
0WBg96J5zFWhRdq4IDShF2zfi4XZZP3bldJVG2UOo4y7p431Ch1jUBQ-jkCcwKI5ZD-31ws3
5ttl5JdN34TUWZ3vbQNuxoFGcf1wbcUMpHkshAIW+vHuj-d0ObDfX8jDX+OdkLm7D6TaauFX
N2VnnlU2SsEg4Mj1O2AQpIlCzSkXWQ1rZkv7Ep8zGD8Ft-J7KZ4zG2fYom6p9rJbb8aKxaCq
2dR13lL1cRpQnK5+qz1cC8XYAGVdK5GQJ9BcC16gp+NFWQjUHmYqwr3o-+jgPHwX85fOAxbU
pMFMv5HlwUXiXUBAO2uInX326tp2CeBgVbSnDxKRrO8166LVPD8AUeCNc4lI-wIZDDgV6JUp
9qRoR-cIB4O-O8fz1B4KpX9NJeoNeeY6Zde0SpLq4kjfL3ySzJZGJm34qt41bkWaRkRfiB+T
Rr--79c9zWG-HrYzZYChl1bqzMFubmXqWd72uAYLDqfuXsRzTzI0naBzkcNFmjkPZG5WjDtu
BI7hMMd4krfgozjp8TdzI2g1--E++++6+7e3u07vn2GFRE6++5o3+++7++++JKtdR12iN4Nh
bNFDHxgk3A1Rd6aHzc4Sdb59YJoa0h6Y76E2dJ5FGVgpbhVhAyq1KYphQBk-2tRxY2Yvvfsj
hGwkOPQhQN9GIf38inXD9rvjxzvNTme6yDr-KFDhB8MKEWHkRqnW0nZhKbchRy3GaSKGGQGp
yFJNtqmYliODYho-RXJKtYy2KzFOAQ3hWrFNf4eysCdpOolZ1+djbfHxcrRRwe5JCFe2PJ97
***** END OF BLOCK 8 *****



*XX3402-050610-200797--72--85-32366------MWSORT.ZIP--9-OF-12
zcd6G3kPFiSAXwEhUHhJpHwmdwMjJyxuR+dqzGnoEgdX9kH79XDvIBp5I2KsnpiFW+4vOOVO
R-8J-8c+JvFCmzK+rI2I-m-DyL-gT8mYk-lJFnPdoUi6P9rayTt4OPv4RdOisRb3uLamyL4o
P9uvNDtmbTYiEdUQntEG54STTSr+Q9Fx6vRbVTrKr5vX7Aa9SQ-s-13kVx09jVm-B98WgC22
pr8DScSEFRcXdeloSNB-4VcGt0rxIfHIS95QkhdF9nnxzzth2XO3qCj-fHQEIweLCZU7e+Gi
IdLX160CyXmuRlyn8NJHrvOCSe3MHjNdvWlKumujphjJOZIT1UuwPNz7K9puR4vAGpIjzCKp
Sgf7dg7sjsunQS-trbMUsFAHgrU-NOuUagyUwUbuXhOl8cQdetSINs3HLi5gDgDNKtfITr-e
VsQD8OZ9ZsdbfN1qQd79W8H1mH4JPW2o3zdYTWgSYTrtl4pJyt6ZQo-H6esdqF4GTIu4UYOi
9y3a-blsPtGQEAEgDK6UCsGcnIQ4QV6VJ3GeF7k5NvgY0SKAmYaAPHIx3aegBLfe2YrQ2pkz
3KD8fk-jniDA30irAbwJCeJplL716FI1iLUXwRAPKPESzEJEGkA23+++++U+GJjJ69pOmxW6
++++j+++++k+++-EQaxeNKBoAGtYQ56f8AdD9ofAJEUcmgx8HGslhCPZsiIe9IshtiJGI519
9wchpU4lEjAmGkkJAjAIpA2gjM92MbK3Od0wMGpMGvJ8Y68KLd-fQ0q6ZtGObdY5oiRMI70H
aNlMYdaTdyQ7p7aNa7BNZKeB9iJQZ7dMYUcmHWA2P8UCq4t1HEmJEOJtE95Ij-ExLWs+I2g1
--E++++6+04PuG6TqAJH7+6++DY1+++A++++I57jOaJXR12iN4xaNJBVPxck2DoS8TyVjq-8
0iouJTY+7-qA336Gc3jJ1mPlUYik6wRNmrvxvXakIZKFrhqvCxhrnwvHGCpfIL5xv1e1k5CR
6K+20+2Fs+vkDT-RNkmMUDs+H+2ls-skErMCG2+T++h+0gU+Gw+8g+MwcjUbj3zkoepu5Ehd
4fi6m7dd8KFdyJ68AuU2OrUHf6LA1bLb3CepiGKPO7Kz-w8Bu0e4MEHGNMwYoffnLQRpba6V
RpO+SpPTYFMsPBuOiXLnnMgxSeFYcmcye4ho4T7BKovYPqI53n6p9ByZsWwDzCjSHFzvj7r3
jDvBpRRfYarDGXuYxcCyzurTwuUkSiAVPr6hOWCI14krcR+wBoc9rXmTye-Mo+ZknZDCR9tB
aBYGGSUwqfw7JeDsgSTRYiYk57vgANnS7yEw978AH-N3moZbPG3NkgYkKgqEXf9dMXbnCkY8
UGtNpEF51J9JudlHAsUg4zuz-wxCYX1BxhlkXI2KfPEQdKDJ4B8m2XZvbrh3RIEi60nJHqFS
hEKbu2bdEKgIFMShe+efD5hFaj8s2fe3ngS9slK5mbXAdpfP9dl2wvBwKjBQg8d9W1zAq4UM
qmQRetlJi9ySXz294ewYSbZpyObTWmYzM2XwH2kSNXEq1MKrxD3u2Hai0zkj5XtAGV8FfARJ
AGxNBJ9pEMhmOou-H9C0vtbSEPwtdEGhk5OmKoLDiqVnAzj+DVp3zSotTWzLyEREGkA23+++
++U+PFHb6gngxkoc-+++KUo+++Y+++-JPaZoAGtkMLCZJphD6nQITYTWDvXGGYnOA08gJ8ZY
IsYBI02h9BdYhEyf6XYn7lCL4LhYCmEIwRxvXiqtt+N-nEBX5rzbubAlQmYgystzSjr1UwA1
6Grc8Iy+BbA1tj0+gFx0dadViik4XC2Ns4foN9tPYSBea5BXWDGLtiJA72FGoad3VpR83zWt
21lLaSaGg82eVZPHsQWaMJIgFiROwmROLL3Xlu6+Nstx8c4MlWGclkMg6KqFqrPcU95DQqiJ
zCCAXTqevwaLeP0z6t4yzHOmRv6C1THS1jfd1jf5RTdMwyHVAxQYe3ejgelnTC2Hm6be3arW
uFelp0e-R8uVwbSMWyEV4c3AEGDquyETG4lb+oq-4afU3jP2tgdgEDjgYKhqbZWV7-6Rliwq
VJF-rhCy8jPjUtyy1ztlHrVxUQANZxYS2EjmLl3TOj46kTSAnynCPswjs05baZA6EP6LVtlD
I2kBR9hhCBHWGUCjV9OiAAt0UHWJLoiEji06rinQ6JIKYRTeH-FZ1UJ6upEFtTb1BzNfT53p
wx9IsRo3qWul0iz5PcKgsseY6J2uxSPvbt+nbZhqVbKiVQnufPD8-yQ3ym8A-IR5koN8ipME
s3uwDvifZB8Ka8sls2gwiAOaZM3q6dj9CNTzUgX6jkZYEUPp0q3bEJ9Y3ATL3UfnAwSp65Zz
RytNeZWPlzqa3C+Me8r23dPcq00sK5bajOdwOkkVNS7Gm-mAAtxwbe9N74IeQUXwNXpIMgKp
hY3WqfvZy567mFl1O4RE6P-9WYmGx4XOPKCjY5H90uWGaHpz2AQjMOrFEVhBqqSzjHEuVI9+
5Czootzgl4ZP1tCNeILVVoFotDla1oeW1om8N4NN-hAt-Zam-KXwz57Iew6T9AJO99pWWjF7
hLA756wgpnJqAICTa3GKUNeWxJii1nhUaYgAVKYfF7QAyL7op+sRzXMizlMKYQiNBbj6njis
mjE-Amj5DfzCorEPft-773PQfppiJdKreUk2JyOl5l5lY7Si7Ew0vX9bdM2oJ1L-2qfJDUge
JHuD9PKu0POuiC-9Zwf5jE0c8u2RxuOMahdhtvXjDz3PkuY8P2ed+Ip7P-NB2DXuz8fjmPQE
0YHJDq9DtQljRwF-imI4I5EfQVwSrls5vTtMMOH5j4vdyuRbYqcyKusoVAhPeReOuawuv5QO
wyMIPaLsbjSxGwTiuRTGUNLKe8aPFkd7J7AvvxOwylKkGzCb2CGVaYhvrDBKI05y1mhqDmtq
lRXPY5UPxhSrlyiYrPRKJ1PZLWcX8DS0rWq8gICvv4GDc9AQg4x5B07vLIMTT7XS8TRTEaTv
RDfaFUHel6RymHKAQQd3MS+uCNqeMLNNWrlOYpyhgfRSL6oR4sAWRq4zEOQ+asGBOjQuzFK4
ehTulzbPHLMnUjWB1kzy+p-9+E6m0lE++++6+-8PuG7ub6jY+Uk++7OL+++A++++++++++2+
6+0qUE++++-hRpB-Qb7VSGtkMLBEGk20AUgI++++0+0OVSUWSwl2YLI0++-x-E++0E++++++
+++-+0++hc2g1+++JKtdR12iN4NhI2g-+X693+++++U+GJjJ69pOmxW6++++j+++++k+++++
+++++E+U+9O-m+s++3-mPqdZMrEl9aFkQZ-9+E6m0lE++++6+04PuG6TqAJH7+6++DY1+++A
++++++++++2+6+0qULcD++-EQaxeNKBoAGtYPqNEGk20AUgI++++0+-h3CQWnCnr1GU2++-O
1E++0E+++++++++-+0++hc562E++JKtdR12iQ43nI2g3-U+++++3++I+5+2++-QK+++++3-9
+kE8++++++-kVj6W7SSITO2I++0V3+++1++++4NjRL6hRq3t9bddQ3-9+kEI++++0++kNSYW
1M0K1Zc7++0vD+++1++++4prIo3mQa3t9b-VQypPPKwPBl9yLe1zMJ+ICCYeuqkbRoqZGk5L
eLg4PAKBrDO1sE9I9WLlgYieL8tZbS5zTXDQBytexJP7HVJM086JCNltm7ZtVaiEgFE4kabz
F4gqurvtlNRTD5nxsS0F5cEoL+yNlyZ55D26yfDc3mC0e+Kz0SafOKE5aBY2FE0irgqYJEBj
sTTfv2SLieuR9YPTBsThxi2he03Q8Kgb2SgfPOnQeEcbH5AI5wPGAo77O7kP5VupU9uCCxas
NUTCwLhYBJXse0IS7ANwDVEGQNglVs48dQyok7xcZI2a3+4HDYeWfh+8Wm3-cG4t5V2VX0++
dI2eovNEgTyGul2bm5+GX7EKNVmG84SFs-coNnsP--maq65ugAQ9K-Gp5sgZ8u0yHHcPpyw5
zyKSOJ9jF6gvNekUkBYZiyz+VN6Xb4wruJM4FPZjTwG1E5Wdu+ITaY6Ks+2CQ7K22GkEzyAy
4+K5PLVAdHy6oLU1QJm61jmUJA0Nv0Nhbd8FoP3bQ63CQRu4Bl1hfmm6SOuraQfuD-RxFsxe
pUJplvIKDYx3Q46SxqBoDu3co4lyZ5s993-wahBN1CXlyqFliDHhH6cJTYnW6pbu72uIHffg
oWQH9-dLSwH8jNSwZHtSHpLyCBMwPnxHgSsIG39ENtaZ3ZnnQ76yxeQgSSkIyNEBCAIEBauw
IyjkZ2qM7wmgIqsjpeHDHGPHuD3dJLty2Lywbq-CnAQM3Abs2nSBQybnyllCgpB8NJTTJJkJ
vhcg9d7sPcVB9Jer-etGGUORSLuM5zUCDPHqE1RdpcX9TDMbjhwcHu1eZE9E8SO7fWesM73N
j3stfukxyEbLNUPZy9+2Z+MBH74RSDeXCcla2hqI5LGPcojIc9xH5SXA9V2fWsAtHJZ2Cv4P
cgVutW-LUX2FnqAuhSZ2QC4rO7l27PSVWiIeb+EwtB6kKa7eQKYdnvvqQc6Ow74EOPsFwI1b
9Fla0KU7eBF0JE3zbv2Ume82W7fOAUAZCYeA7plIC9k+ht9kG2YGhUZTJT4WsLFs0HEqNwfG
RX3A7zVxUVU9bYn6DNoCQDcjPPbKZMYEoALHm4bMUGSYpv+KakK0FUv-cahGVKqsg7fni2ck
m3+0kwbT+YSKmLBEldk0mkRL6BCNhWJerH9lK94GhXhKQVh3phTNmY6qtsB0pr7emTJzs-5a
bkqx6eRlERBqOgtGm0uUEyZt9hsYkfSYVInOrbDmYZLNR60uDguEtWdnI4uV8Slz+qyCjXhS
dKqB6dLPmLIXQ2SqamkA0k9ZLT8ksFHM+grTcMxvajT1FfOwnSckdlWj49NgDZY+C8+hCqTQ
IKzkQ+uBAsaootrxsT7UKZ4Zuu6d1ksvvbOtzacNep362B6OR+-5epNhfNp0gOEJg2sUNoMS
fabTXTwM153H+3BAst188qUJ4xnjoqPy3nb2oVd9NCP+tUhwZRFUz2v3E59iclPT3vE492+h
cR6n55oWbSozPdKlg84uo7cFQcE2++3eM-eA07Cr+RE7G3mOEHGlvpS228b3oq8+F03Y-thy
OABzMcM8uDrYgcpv-Xa8X76hF5KZ4Tf0ElXbwa+Gc+s9aAlxpQ8li2A6MsY0-BOywB0gHYsj
sRJFsyWvBqyO9LXpygr-erwSqspxbGwqq69RAIryc20yIV3oEAknJhvthhUshmrJquWSXUKy
8XLQDeehHHjvFf5-faqanLNR-u5Dqbq3r5v7o-gLGYrGZlab7ZXu94NO7BtB-Sth0udx3dTh
Ow8zAGghtqNe8pNKKoebgw-KAeT3lacBfXOuR5cCc6Iq3xeZHotlBrYQr7PddVcIQBihIpF6
tJiAwUQHjxd6ytWbkCcgmp8oWRlWj7LKmUnaoSzMiyg2p28nxDYgbJigmZ8kJakHpnchnan8
gxU5jWUcvtDmFEtXSEOWp+hTZ1tzrfjDllTvtBnbsMhGDvpEdu0mJydgqkgvr31hnwNdunpA
PFXgd9kh9Kpz9cBrl1gfCCS7GhOqpKD93JZ092h7NOwwxIlYgNwjKRjiW1xDeZVOlNNLgCQb
WeRropyJ7rPdddqnl0TzMwmeyj503DPniH53ovk3DpjhzintsZDywLOfzSN9mP8T3vtssEju
D-RTf5s9wRL4F9193smhOzX0yfpyX4zB0kgtMGDLPPsnr9LjBWPlzT9SEf7MEVFDY5nZaflH
1utWrDpqs274LQmaKmHUSbzKrRVxixp3DGZpvJw0fiL-9TBjaurdTjjjaTBjjLSOnTqrpNvp
yOBzDvpMeM1ovaaDvef7X+uq4HdCRGMoDfVr0oWcB9ChuZA7NbqZecSR2oQhv1vr36PXPb1L
tLIRvYe49w-Rd6l3LU3yDFNuNvVfcvYKSHKiuv2LKJo5bLfBS2TMOnCU1bcp3n9YqTR1HwY1
***** END OF BLOCK 9 *****



*XX3402-050610-200797--72--85-40007------MWSORT.ZIP-10-OF-12
nPpMFy6ijL6E8KojBzr8xEm4916hsWAiJHkOdyQRURol2R0p7V8YGp+m1URQooExmpcWgYQC
ssUCAYN+-ly14OW72G29Kg+4RDXlpHxSosWTMy3xv8RKnogOM-9MipZkFq1EB+QFHZ0IGEBO
sRePAND+vnrw4hZnzrHkIS0GlmMxUVYJ-iUI7dAnw3VYYHTUUh2-nswQXK1T79rgk4XhcVPU
QBHBu2c-43n3t-9LY2wV4dAuCh2NhM2i-Npd3E71tuSbEB4g3LvTu22kUZsHETohiMCa70t3
N4XtKfWUHBfncOUBzFaV8jt5n66QYlqVzKFlVNn2dUrqC4i6IHFkpkC36lJmCvhcsM5C1Ov4
d+QuKEg49T-Os9SUpk8XTCJSEQh1CCQb1BatWlPNuRyXxDVmlUbfmp6KfWpB2pl1i6QmFzN7
wkY8N9ZYtpVQw8VqstdU9kYtJKK+HEmyuHZB5XMBmYoyBbbZdhGMLqshqBvS-W2bt9-R0S7J
8o2yedSkz4JZm6apAdMcf6WTS9UWJLQAiCX57FJ-Ailvd0jDiJw2nZoqVwauw5+GM8d7NWXu
YGSmswZ7vfITgy5t257bFd0twfk3SrB1SGythsSt4g-lqdMUvQr-R4ck9ZOdoFOsiQOYSZGP
2q7CKXCCLLWeifzKrOswjScGpnp7Xxz6OEw5CzUwocqLGuPFBz+P0rki-v2S2MU9rAQmvbrY
iD5F928r5Lx9vRwSzSjpAJn2zZGAcYns7ut1d3huv6wF9QkEDNN3bnzi1iXz+J-9+kEI++++
0+0OVSUWSwl2YLI0++-x-E++0E+++3JiOLEl9aFaPNqIHozPA-H+rOG7Yzu-beNlmt3R7UfG
70G2-8JFoIcPBNvMPHDhUpdBPL1Q+FCLTN-7Cyuy9vIjA4ar9L4GoZ8lGfgsnmxyvzTyqLwe
WDXxkJYHvHGa3Y6Yw5RgsUgtPJdu9LTVIdbZYYb2hTYJKSRgdAPaXt9R+LMpJiNDV3joKX5-
PMhoKOleji1eRKhANEk8PtuozOBrLT8VpHYOV4pGmTu8G2VQ4oPbX6z29M2vJRIzAeT49pTj
SbE8Rjogx298Mmw2mGsnyp1RFp-3iAxPYMU-iqacKbEGZEGe+3SoHgjpUBp-3+QUHzZkP5mg
dA+QJIQquR69W4mxtjbyFaaylbOKfi5NlSZtgjZlh4myiqHyQdrt9Y8M5AyI2Vlbbrrhk50o
TGCrNsLxphlysmH7Wrb+S+ElQ6TEWvsQUHGmcf1V-BRmXre5Y2LO6uOgR5aHEFcO2iEhzJ8o
p5WlrA9OIGwwzTzyPF6qVRXfkOor23D8ZndM0OU2fZ8Jskm+XjcwibQTgmaJIxyqXbeVK2vq
OSsgJigifxPPpKdJ5ksCj4qTmJWxSbFin2hJ9znZhLf8mOP0S9yCgr5USRtq6C2H2vBs+KKi
c7fDcD67ycvKgGe58OiLZ4S-IpvVv1v1qJiOp5xkOcS51madGtS8NuqExb8GGsWYkwYlZKsV
B-TuN5sf5d5xyQFhJTiG7LB+Im8i8RYFYbpCVc74fWzVNUNwS4yIb21291pW61i2eAp5-b6G
6JFIeYGQ-qSv7+bZXAd7X4opDFNef1JuuV7Br-BQDlJXmew+PwvXn-Efhn7z3HeZRQJmEm2J
+vZs6z5H4pao5jo3I2g1--E++++6+2ZPpG0xKgjMW++++9k++++A++++I57jOaJXR12iN5-m
8mX8Hmx8n3I68AfDGYoiAPHatS9Z8WpC9SPZIZ-kmmz89RM-gI9nAYgA3H9n3BH-99q0l47p
VKeEj42hK2ipGd00ZZuEOr+hW7SIaduN-x9bK30EYtaQK78NbuTb0RGNaNWHKNJeXGvZL7GO
K768AYsX-4mc1hViEooAZI4ZSI0lp9kIDJsi+3-9+kEI++++0+-dNSYW5xX3ImE0++1t+k++
1++++3-mPqdZMrEl9aFjNaJHMKzOA-1x5WbzcPxUGUfhCZLt+0ERX-FG2e-PpEwawM79g0D5
KQhyzSstg37JYRvRinjPRwzCooXhOp3lzSkuUw-nbG3U-+U-2S+Cw1rkLKQAa61y+2k-AS+S
A2Bq1YV+5k+9E+f6+2j+0f+4D89s7vlTwB8hSVo9OFevWAWOOGZYOTZG0XCc-4hs2um3n+tp
tlHehPYZaqWJjkT0XSUeVa22oaKD7B8uwpr5RNtW6LRKU5hKrt2KC4nSafcpwwq9DLeYN8Ae
DeVfR-bmHJhCt4xZ-lQmBGnTdS6j1znfrYoTyvmRlPnynRLLOt7hnocydDO1jjyhrzCcA5fX
6Kxm9KcXZ+lgBu5ED1R80xswbzeUKB+7QAtHnbGyHNXN2YbcDBez0JOXy95brN9dA-mSv14Q
rWTYD0mGX2kKFQh7NqoVKQ97A3fBY6umuK6twng70c2iKRI2FkpGpSeQInC69-jyjkTDHd6k
nTPQQ6p-3eqo58JXpFXGgV6tStxvFLJ29W+gpIxYLfI3dyV7uI3f32K5fOU8enlvINfmi-8u
VQv5WyAJVwdsn8ROqmuQFDCnT3fnL90eGsUznBVc4Bgb5OiQJPWzbczl0lej75dtRTadrsgd
Dq-6z2lA5aMoBUq3hzHlSV2tfUjw9lsyH2cGYOn5JH2jKHJGxI49QahCUImnUiyNrY4zCOI2
fQ-qgZh3nvhcQnDvk1sRFTrhCLsjpzY5I2g1--E++++6+4oItm9AvDQB8+E++3cB+++7++++
JKtdR12iQ43ndJRPHmAr35t5sXysoYdAqX+Wf3GdN3C71J+V9GnON9IDem6tAmQHZlZvN1gY
3D5TSsvhiSE4EQo1MlxztydnALAd9DiCTrfxksD1+m2hu0ZDU1Nn+yPkU92TEeNeMPfg-cnV
4S-ex4GyKt5XOdVnMsXoZyPZH0F2Ih7eFMRLGVTsiF+wJtbdYf0V8cNKoy56da3J92PbKjAb
KZplMwSW+4SCTGe-aAMYeAQ4903hYRhqu60lnrBfZTnXX6rxeiz7ZuakjmCFjjoqgbSm1Uro
rUvuuEvulrLuKDDYsHDL78VOfv8gQrnV2wW7uVNhsiYOgREeULGicT7ra6jY6Fe-H22XxijY
5oVgNkBBUFdes-PqlCP8P21vv73fRdtMcGEG5QPjBcJIERvHjWfqvsCTjUzyQIxsTM514NTN
5V29wZwFLqflWA5rXAzgnayD9y+VttdH024m3sSQHp-A1LGvPHXIsYc1fsGqfX1CEc2sZJx9
Y9vUWBvgr03J3d5LuYkINEs3GChI2SLtknTqOrllRTDGpC5R-RcigEfjlqu3fCC8d03FCjLa
ytyEAttPRcNpfcLAyeqnmUTb-TgWX+J5FwB4GfhK2C-Sj1yvetHGZdWiAS-9D9X4ddK-RW8P
mnaLzs96m9w7N264xEhVNo3Gt-H5plM8wnD5hG-tTrTiKOdMawTxdVHU48Whl-OKuBUUi3Vt
tfqeT4gA6KLWIgUQX1CTT7uWqGFZ8b66z4MxJ493hPN-MheytTVm0QYQEqVbI04kGsdAYjFc
qapXft-omkicYdYxTl159q4hoI6PHRhbjvooCcJ0k-njxBCTvAFdKkyHaOZ3sMR2RCHwNUx8
cUxAWaFaKEPHCENNgUJczDlmJ8j05mn3KWmxMcfoGPJn0FmD9BQpRX31btVIZc4OcjJPfUwv
M7d916Jd8oGL1DZmRBEC5Tsq9jwK3d59aHNvmAvviAfo+HAflnuznhBo4uyEGGFKr8xRPZOJ
hucA-3TagFwFwN0LfWID+ismtuK-B3EpkFBepHs98ZIyXmqpiUaqifXUGtT8lvo+e0iV5TSa
a7fOPSSsvnzlKwCd0al8eE3BGKkKHF1syjmevwar2+d2pHxWnyLAPrT2EPgZ-Z-o8r6T5hwS
-yryK44YlvliuTibNtBeDZiiB6H9KubOaidjCilr4jDa34tZy7vrjIj5vibLoc4JpeWdaoQ8
GJGHCyzKjDgJg2jndl1YcNd9SxnnJZ+VzUwfRXwiRgLMqt-s4zPLhwTfdBqrJZEqtJse6mXr
UhshWf31iylYXu0n59-jFnEWSpp45rmMrWbrLo7byrHutYM2ugG5TgYpX558FK5UCXaRea3q
KMhwKdBTfP8rLZmB5Fi16bRVjo4b+7i2XKfrCjoJVefLygTtqopqAs9sXEwDzUBEGk20AUgI
++++0++kNSYW1M0K1Zc7++0vD+++1++++++++++-+0++hc2+++++PLRHEL7mMLYiQ43nI2g-
+X693+++++U+acLc6bjAF73p+U++TEI+++Y++++++++++E+U+9O-V+Y++3JiOLEl9aFaPJ-9
+E6m0lE++++6+2ZPpG0xKgjMW++++9k++++A++++++++++2+6+0qUG+A++